// generated by Fast Light User Interface Designer (fluid) version 1.0104

#include "umed.h"
#include<stdlib.h>
#include<FL/Fl_file_Chooser.H>
#include"engine.h"
static int tile;
static char currentlevel[256];
static int proposed;
static char levelComments[1024];
static int timer[2];
static int fruitRequired[2];

Fl_Double_Window* make_box() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(104, 100);
    w = o;
    new Fl_Box(25, 25, 25, 25, "label");
    o->end();
  }
  return w;
}
#include <FL/Fl_PNG_Image.h>
static Fl_PNG_Image *mapImage;
#include<FL/fl_draw.h>

void Fl_Editor_Map::draw() {
  proposed=0;
draw_map();
//proposed=1;
if(proposed==1) {
int x=Fl::event_x()-this->x();
int y=Fl::event_y()-this->y();
int w=1,h=1;
struct TileProp *tileProp=tile_to_prop(tile);

x=x/TILEWIDTH;
y=y/TILEHEIGHT;

if(tileProp) {
	w=tileProp->gfxw;
	h=tileProp->gfxh;
}

int i,j;
for(j=0;j<h;j++) {
	for(i=0;i<w;i++) {
		draw_tile(tile+i+j*TILESACROSS,(x+i)*TILEWIDTH,(y+j)*TILEHEIGHT);
	}
}
}
}

Fl_Editor_Map::Fl_Editor_Map(int x,int y,int w,int h):Fl_Box(x,y,w,h) {
}

int Fl_Editor_Map::handle(int event) {
  int state=Fl::event_state();

if(event==FL_PUSH || (event==FL_DRAG && tile==-1) || (event==FL_DRAG && tile_to_prop(tile) && (tile_to_prop(tile)->flags&8)) || (event==FL_DRAG && tile_to_prop(tile) && (tile_to_prop(tile)->gfxw==1) && (tile_to_prop(tile)->gfxh==1)) || (event==FL_DRAG && (state&(FL_BUTTON2|FL_BUTTON3))) ) {
	int x=Fl::event_x()-this->x();
	int y=Fl::event_y()-this->y();
	int w,h;
	struct TileProp *tileProp;
	int drawTile=tile;
	if(state&FL_BUTTON2) drawTile=M_SOLIDGROUND;
	if(state&FL_BUTTON3) drawTile=-1;

	x=x/TILEWIDTH;
	y=y/TILEHEIGHT;

	tileProp=tile_to_prop(drawTile);
	w=1;
	h=1;
	if(tileProp) {
		printf("Setting tile %d,%d '%c'\n",x,y,tileProp->ch);
		w=tileProp->gfxw;
		h=tileProp->gfxh;
	} else {
		printf("Setting %d,%d sky\n",x,y);
	}
	save_undo(x,y,w,h,drawTile);
	set_tiles(x,y,drawTile);
	damage(FL_DAMAGE_ALL,x*TILEWIDTH,y*TILEHEIGHT,w*TILEWIDTH,h*TILEHEIGHT);
	previewMap->damage(FL_DAMAGE_ALL);
	previewMap->redraw();
	redraw();

	return 1;
}
#if 0
if(event==FL_MOVE) {
	int x=Fl::event_x()-this->x();
	int y=Fl::event_y()-this->y();
	int w,h;
	struct TileProp *tileProp;

	x=x/TILEWIDTH;
	y=y/TILEHEIGHT;

	tileProp=tile_to_prop(tile);
	w=1;
	h=1;
	if(tileProp && (tileProp->flags&8)==0) {
		printf("Setting tile %d,%d '%c'\n",x,y,tileProp->ch);
		w=tileProp->gfxw;
		h=tileProp->gfxh;
	} else {
		printf("Setting %d,%d sky\n",x,y);
	}
	damage(FL_DAMAGE_ALL,(x-1)*TILEWIDTH,(y-1)*TILEHEIGHT,(w+1)*TILEWIDTH,(h+1)*TILEHEIGHT);
	redraw();
	return 1;
}
#endif

return 0;
}

void Fl_Preview_Map::draw() {
  int x=this->x();
int y=this->y();

if(game.w<1 || game.h<1 || mapImage==NULL) return;

uchar *buf=new uchar[game.w*game.h*3];
const char *gfxBuf=mapImage->data()[0];
int i,j;
for(j=0;j<game.h;j++) {
	for(i=0;i<game.w;i++) {
		int tile=game.map[i+game.w*j];
		int pos=(i+game.w*j);
		
		buf[pos*3]=0x88;
		buf[pos*3+1]=0xcc;
		buf[pos*3+2]=0xff;
		if(tile>-1) {
			int gfxPos=(tile%TILESACROSS)*TILEWIDTH+(tile/TILESACROSS)*TILEHEIGHT*TILEWIDTH*TILESACROSS;
			gfxPos+=TILEWIDTH/2+TILEHEIGHT/2*TILEWIDTH*TILESACROSS;
			gfxPos*=mapImage->d();
			buf[pos*3]=gfxBuf[gfxPos+0];
			buf[pos*3+1]=gfxBuf[gfxPos+1];
			buf[pos*3+2]=gfxBuf[gfxPos+2];
		}
	}
}

if(game.w<w() || game.h<h()) {
	fl_rectf(x,y,w(),h(),0,0,0);
}
fl_push_clip(x,y,w(),h());
fl_draw_image(buf,x,y,game.w,game.h);
fl_pop_clip();
delete []buf;
}

Fl_Preview_Map::Fl_Preview_Map(int x,int y,int w,int h,const char *s):Fl_Box(x,y,w,h,s) {
}
static int dirty;

Fl_Double_Window *mainWindow=(Fl_Double_Window *)0;

Fl_Round_Button *rb01=(Fl_Round_Button *)0;

static void cb_rb01(Fl_Round_Button*, void*) {
  tile=M_SOLIDGROUND;
}

#include <FL/Fl_Image.H>
static unsigned char idata_solidground[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\215t9\377\220v:\377\220w:\377\
\216v9\377\214s8\377\212r8\377\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\214t8\377\222x:\377\225{<\377\225{<\377\222x:\377\214t8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\214s8\377\220w:\377\223z;\377\223z;\
\377\220w:\377\214s8\377\212r8\377\212r8\377\212r8\377\215u9\377\223z;\377\
\226|<\377\227|<\377\225{<\377\222x:\377\214s8\377\0\0\0\0\212r8\377\212r8\
\377\212r8\377\212r8\377\214t8\377\225{<\377\236\202?\377\241\205@\377\241\
\205@\377\236\202?\377\225{<\377\214t8\377\212r8\377\212r8\377\214s8\377\222x:\
\377\226|<\377\227|<\377\227|<\377\226|<\377\222x:\377\214s8\377\212r8\377\
\213s8\377\223y;\377\227|<\377\227|<\377\227|<\377\227|<\377\226|<\377\220w:\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\222x:\377\236\202?\377\
\242\206@\377\242\206@\377\242\206@\377\242\206@\377\236\202?\377\222x:\377\
\212r8\377\212r8\377\216v9\377\225{<\377\227|<\377\227|<\377\227|<\377\227|<\
\377\225{<\377\216v9\377\212r8\377\214t8\377\226|<\377\227|<\377\227|<\377\
\227|<\377\227|<\377\227|<\377\223z;\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\225{<\377\241\205@\377\242\206@\377\242\206@\377\242\206@\377\
\242\206@\377\241\205@\377\225{<\377\212r8\377\212r8\377\220w:\377\227|<\377\
\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\220w:\377\212r8\377\214t8\
\377\226|<\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\223z;\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\225{<\377\241\205@\377\242\
\206@\377\242\206@\377\242\206@\377\242\206@\377\241\205@\377\225{<\377\212r8\
\377\212r8\377\220v:\377\226|<\377\227|<\377\227|<\377\227|<\377\227|<\377\
\226|<\377\220v:\377\212r8\377\213s8\377\223y;\377\227|<\377\227|<\377\227|<\
\377\227|<\377\226|<\377\220w:\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\222x:\377\236\202?\377\242\206@\377\242\206@\377\242\206@\377\242\
\206@\377\236\202?\377\222x:\377\212r8\377\212r8\377\215t9\377\223z;\377\227|<\
\377\227|<\377\227|<\377\227|<\377\223z;\377\215t9\377\212r8\377\216u9\377\
\225{<\377\235\201>\377\235\202>\377\232\177=\377\225{<\377\222x:\377\214s8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\214t8\377\225{<\377\
\236\202?\377\241\205@\377\241\205@\377\236\202?\377\225{<\377\214t8\377\212r8\
\377\212r8\377\212r8\377\215u9\377\223y;\377\226|<\377\226|<\377\223y;\377\
\215u9\377\212r8\377\216u9\377\226{<\377\227|<\377\231~<\377\234\200=\377\233\
\177=\377\222x:\377\214s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\214t8\377\222x:\377\225{<\377\225{<\377\222x:\377\
\214t8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\213s8\377\214t8\
\377\214t8\377\213s8\377\212r8\377\212r8\377\223z;\377\227|<\377\227|<\377\
\227|<\377\227|<\377\227|<\377\223z;\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\214s8\377\220w:\377\223z;\377\223z;\377\220w:\377\214s8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\227|<\377\
\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\214s8\377\222x:\377\230}<\377\233\200=\377\234\200>\377\233\200>\
\377\225z;\377\214t8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\225{<\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\
\377\225{<\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\216v9\377\227|<\377\236\202?\377\241\
\204@\377\242\205@\377\242\205@\377\236\202>\377\222x:\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\220w:\377\227|<\377\
\227|<\377\227|<\377\227|<\377\227|<\377\220w:\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\220w:\377\234\201>\377\242\205@\377\242\206@\377\242\206@\377\242\206@\377\
\242\205@\377\230~=\377\213s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\213r8\377\220w:\377\225{<\377\227|<\377\225{<\377\220w:\377\
\213r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\220v:\377\237\202?\377\242\205@\377\242\
\206@\377\242\206@\377\242\206@\377\242\205@\377\233\200>\377\214t8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\213r8\377\
\214s8\377\214t8\377\214s8\377\213r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\215t9\377\234\201>\377\242\205@\377\242\206@\377\242\206@\377\242\206@\377\
\240\203?\377\231~=\377\214t8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\224z;\377\236\202>\377\242\205@\
\377\242\205@\377\237\203?\377\232\177=\377\223y;\377\213s8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\214t8\377\223z;\377\227}<\377\231~=\377\227}<\377\224z;\377\215u9\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\214s8\377\216v9\377\220w:\377\220v:\377\215t9\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\216u9\377\222y;\377\225z;\377\222y;\377\216u9\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\216u9\377\226{<\377\227|<\377\227|<\377\227|<\377\226{<\377\216u9\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\220w:\377\225{<\377\226|<\377\223y;\377\216u9\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\223z;\377\227|<\377\227|<\377\227|<\377\227|<\
\377\227|<\377\223z;\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\221x:\377\234\201>\377\241\204?\377\
\242\205@\377\240\203?\377\231~=\377\216u9\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\227|<\377\227|<\
\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\215t9\377\233\
\200=\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\241\204?\377\
\227|<\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\225{<\377\227|<\377\227|<\377\227|<\377\227|<\377\
\227|<\377\225{<\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\216v9\377\241\204?\377\242\206@\377\242\206@\377\242\
\206@\377\242\206@\377\242\205@\377\234\201>\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\220w:\377\
\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\220w:\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\216v9\377\
\241\204?\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\242\205@\
\377\234\201>\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\216u9\377\223y;\377\226|<\377\226{<\377\226{<\377\225{<\377\227|<\377\225{<\
\377\220w:\377\213r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\215t9\377\233\200=\377\242\206@\377\242\206@\
\377\242\206@\377\242\206@\377\241\204?\377\227|<\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\216u9\377\231~=\377\240\203?\377\242\205@\377\241\
\204?\377\235\201>\377\223y:\377\214t8\377\214s8\377\213r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\221x:\377\234\201>\377\241\204?\377\242\205@\377\240\203?\377\231~=\
\377\216u9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\227|<\377\
\241\204?\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\233\200=\
\377\215t9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\220w:\
\377\225{<\377\226|<\377\223y;\377\216u9\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\234\201>\377\242\205@\377\242\206@\377\242\206@\
\377\242\206@\377\242\206@\377\241\204?\377\216v9\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\234\201>\377\
\242\205@\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\241\204?\
\377\216v9\377\212r8\377\212r8\377\212r8\377\213s8\377\214t8\377\214t8\377\
\213s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\227|<\377\241\204?\377\242\206@\377\242\206@\
\377\242\206@\377\242\206@\377\233\200=\377\215t9\377\212r8\377\212r8\377\215u\
9\377\223y;\377\226|<\377\226|<\377\223y;\377\215u9\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\216u9\377\
\231~=\377\240\203?\377\242\205@\377\241\204?\377\234\201>\377\221x:\377\212r8\
\377\212r8\377\215t9\377\223z;\377\227|<\377\227|<\377\227|<\377\227|<\377\
\223z;\377\215t9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\216u9\377\223y;\377\226|<\377\225{<\377\220w:\
\377\212r8\377\213s8\377\214t8\377\222w:\377\227}<\377\227|<\377\227|<\377\
\227|<\377\227|<\377\226|<\377\220v:\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\215u9\377\223y;\377\226|<\377\233\200=\377\236\202>\
\377\232~=\377\227|<\377\227|<\377\227|<\377\227|<\377\220w:\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\215t9\377\230}<\377\241\204?\377\242\
\206@\377\244\207@\377\245\207""A\377\237\202>\377\231~<\377\227|<\377\227|<\
\377\225{<\377\216v9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\225z;\377\242\205@\377\242\206@\377\242\206@\377\244\206@\377\250\212""A\377\
\244\207""A\377\234\200=\377\227|<\377\226|<\377\222x:\377\214s8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\233\177=\377\242\205@\377\242\
\206@\377\242\206@\377\242\206@\377\244\206@\377\245\210""A\377\230~<\377\223z\
;\377\220w:\377\214s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\233\200>\377\241\204@\377\242\206@\377\242\206@\377\242\206@\377\
\242\206@\377\241\204@\377\216v9\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\213r8\
\377\220w:\377\225{<\377\227|<\377\223z;\377\216u9\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\227|<\377\236\202?\377\245\
\207""A\377\252\213""B\377\253\214""C\377\252\213""B\377\240\203?\377\214s8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\213r8\377\220w:\377\227|<\377\227|<\377\227|<\
\377\227|<\377\226{<\377\216u9\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\217v9\377\235\201>\377\252\214""B\377\261\221""E\377\262\
\222""E\377\257\217""D\377\241\204?\377\216v9\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\214s8\377\225{<\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\222y;\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\235\201>\377\252\214""B\377\254\215""C\377\252\214""B\377\246\210""A\377\242\
\206@\377\231~=\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\214t8\377\227|<\377\227|<\377\
\227|<\377\227|<\377\227|<\377\227|<\377\225z;\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\241\204?\377\242\206@\377\242\
\206@\377\242\206@\377\242\206@\377\242\206@\377\241\204?\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\214s8\377\225{<\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\
\377\222y;\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\241\204?\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\
\242\206@\377\241\204?\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\213r8\377\220w:\377\227|<\
\377\227|<\377\227|<\377\227|<\377\226{<\377\216u9\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\231~=\377\242\206@\377\242\
\206@\377\242\206@\377\242\206@\377\242\206@\377\231~=\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\213r8\377\220w:\377\225{<\377\227|<\377\223z;\377\216u9\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\216v9\377\233\200=\377\241\204?\377\242\206@\377\241\204?\377\233\
\200=\377\216v9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\216v9\377\225z;\377\
\227|<\377\225z;\377\216v9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377";
static Fl_RGB_Image image_solidground(idata_solidground, 32, 48, 4, 0);

Fl_Round_Button *rb02=(Fl_Round_Button *)0;

static void cb_rb02(Fl_Round_Button*, void*) {
  tile=M_SECRETAREA;
}

static unsigned char idata_secretarea[] =
"\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\365\212r8\
\336\212r8\277\212r8\256\212r8\263\212r8\276\212r8\306\212r8\316\212r8\330\
\212r8\356\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0";
static Fl_RGB_Image image_secretarea(idata_secretarea, 32, 48, 4, 0);

Fl_Round_Button *rb03=(Fl_Round_Button *)0;

static void cb_rb03(Fl_Round_Button*, void*) {
  tile=M_FANCYSOLIDGROUND;
}

static unsigned char idata_fancysolidground[] =
"\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\211q7\377\206q6\377\177p5\377uo2\377kn/\377""dm\
-\377""cm-\377mn/\377{p3\377\207q7\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\210q7\377\200p5\377po0\377""cm,\377[l*\377Wl)\377Tk(\
\377Rk(\377Qk\'\377Ul)\377gn.\377~p4\377\210q7\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\211q7\
\377\205q6\377wo2\377""em-\377\\l+\377Xl)\377Tk(\377Ok\'\377Kj&\377Ij%\377Hj%\
\377Ij%\377Mk&\377[l*\377ln/\377~p4\377\207q7\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\205q6\377to1\377""dm-\377Zl\
*\377Wl)\377Tk(\377Rk(\377Qk\'\377Kj&\377Gj$\377""Ej$\377""Fj$\377""Fj$\377Hj%\
\377Ok\'\377_m+\377vo2\377\210q7\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\205q6\377qo1\377""bm,\377^m+\377in.\377xo2\377\
\203q6\377uo2\377""cm-\377Zl*\377Wl)\377Ul)\377Vl)\377Zl*\377]l+\377Yl*\377Pk\
\'\377Kj&\377Kj&\377""Ci#\377""Ci#\377Hj%\377Qk\'\377""am,\377\203q6\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377qo0\377\\l*\
\377Qk\'\377Mk&\377Rk(\377""em-\377nn0\377""cm-\377Zl*\377Wl)\377Xl)\377Xl)\
\377""cm,\377po0\377\177p4\377\204q6\377zp3\377""dm-\377Ul)\377""Ej$\377""Ci#\
\377""Dj$\377Hj%\377Tk(\377yp3\377\211q7\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\210q7\377_m+\377Qk\'\377Gj$\377""Fj$\377Jj%\377_m+\377[l*\
\377Yl*\377Wl)\377Uk(\377Xl)\377hn.\377\200p5\377\210q7\377\212r8\377\212r8\
\377\211q7\377\205q6\377vo2\377Pk\'\377<i!\377:h!\377@i#\377Mk&\377hn.\377\
\205q6\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\203q6\377Yl*\377K\
j&\377""Bi#\377""Ai#\377Ij%\377]l+\377Rk(\377Tk(\377Uk(\377Xl)\377""dm-\377\
\200p5\377\211q7\377\212r8\377\212r8\377\212r8\377\212r8\377\207q7\377po0\377O\
k\'\377>i\"\377""9h!\377=i\"\377Jj%\377^m+\377uo2\377\210q7\377\212r8\377\212r\
8\377\212r8\377\212r8\377{p3\377]l+\377Lj&\377""Bi#\377""Ai#\377Rk(\377\\l*\
\377Sk(\377Rk(\377Sk(\377[l*\377so1\377\210q7\377\212r8\377\212r8\377\212r8\
\377\212r8\377\207q7\377wo2\377Zl*\377Jj%\377Gj$\377>i\"\377?i\"\377Ij%\377Yl*\
\377""dm-\377\201q5\377\212r8\377\212r8\377\212r8\377\212r8\377wo2\377^m+\377R\
k(\377Pk\'\377Uk(\377kn/\377`m,\377Sk(\377Mk&\377Pk\'\377^m+\377\202q5\377\
\212r8\377\212r8\377\212r8\377\211q7\377\201q5\377ln/\377]l+\377Pk\'\377Kj&\
\377Ij%\377""Ci#\377@i\"\377Lj&\377Vl)\377[l*\377po0\377\210q7\377\212r8\377\
\212r8\377\212r8\377uo2\377[l*\377Qk\'\377Qk\'\377[l*\377qo0\377`m,\377Tk(\
\377Lj&\377Lj&\377[l*\377\206q7\377\212r8\377\212r8\377\212r8\377\203q6\377hn.\
\377Tk(\377Ok\'\377Lj&\377Mk&\377Nk&\377Rk(\377Ok\'\377Vl)\377Tk(\377Xl)\377""\
am,\377\200p5\377\212r8\377\212r8\377\212r8\377uo2\377Vl)\377Kj&\377Kj&\377Vl)\
\377po0\377""cm-\377Tk(\377Ok\'\377Lj&\377Rk(\377kn/\377|p4\377\205q6\377\207q\
7\377nn0\377Rk(\377Mk&\377Nk\'\377Mk&\377Qk\'\377""fm-\377wo2\377nn0\377[l*\
\377Tk(\377Tk(\377[l*\377ro1\377\212r8\377\212r8\377\212r8\377qo0\377Sk(\377Jj\
%\377Jj%\377Sk(\377nn0\377mn/\377Zl*\377Rk(\377Nk\'\377Qk\'\377Yl*\377^m+\377""\
fm-\377gn.\377\\l*\377Mk&\377Mk&\377Lj&\377Qk\'\377""cm-\377\205q6\377\211q7\
\377\201q5\377`m,\377Sk(\377Rk(\377Zl*\377gn.\377\212r8\377\212r8\377\212r8\
\377on0\377Rk(\377Jj%\377Jj%\377Rk(\377on0\377~p4\377gn.\377Yl*\377Tk(\377Tk(\
\377Rk(\377Ok\'\377""Fj$\377""Bi#\377Hj%\377Mk&\377Lj&\377Pk\'\377`m,\377{p3\
\377\212r8\377\212r8\377\210q7\377""fm-\377Sk(\377Ok\'\377Tk(\377""am,\377\
\212r8\377\212r8\377\212r8\377ro1\377Vl)\377Lj&\377Jj%\377Pk\'\377nn0\377\210q\
7\377\200p5\377kn/\377`m,\377Xl)\377Kj&\377""Ai#\377:h!\377""8h \377;i!\377""C\
i#\377Lj&\377""bm,\377yp3\377\207q7\377\212r8\377\212r8\377\212r8\377gn.\377Ok\
\'\377Ij%\377Mk&\377]l+\377\212r8\377\212r8\377\212r8\377zp3\377]l+\377Pk\'\
\377Lj&\377Qk\'\377""fm-\377\205q6\377\211q7\377\203q6\377vo2\377]l+\377""Dj$\
\377:h!\377""7h \377""8h \377""9h \377?i\"\377Pk\'\377po0\377\205q6\377\212r8\
\377\212r8\377\212r8\377\206q7\377Xl)\377Hj%\377Hj%\377Nk\'\377[l*\377\212r8\
\377\212r8\377\212r8\377\203q6\377kn/\377Zl*\377Sk(\377Ul)\377_m+\377wo2\377\
\211q7\377\207q7\377uo2\377\\l+\377Kj&\377?i\"\377""9h \377""8h \377=i\"\377Gj\
$\377Uk(\377[l*\377`m,\377po0\377|p4\377\202q5\377""em-\377""Ej$\377""Ai#\377G\
j$\377Ok\'\377_m+\377\212r8\377\212r8\377\212r8\377\210q7\377yp3\377[l*\377Qk\
\'\377Kj&\377Lj&\377Zl*\377wo2\377in.\377Xl)\377Nk\'\377Qk\'\377Mk&\377""Ej$\
\377""Bi#\377Jj%\377Rk(\377Vl)\377Rk(\377Qk\'\377Wl)\377""am,\377\\l+\377Mk&\
\377""Ci#\377@i#\377""Dj$\377Rk(\377nn0\377\212r8\377\212r8\377\212r8\377\212r\
8\377\207q7\377`m,\377Gj%\377?i\"\377<i!\377>i\"\377Mk&\377Pk\'\377Ok\'\377Mk&\
\377Nk&\377Rk(\377_m+\377gn.\377""fm-\377\\l*\377Yl*\377Ok\'\377Mk&\377""Ej$\
\377@i\"\377""9h \377""Ai#\377""Fj$\377""Ci#\377""Ej$\377_m+\377\201q5\377\
\212r8\377\212r8\377\212r8\377\212r8\377\205q6\377_m+\377""Ai#\377""9h!\377""7\
h \377""6h \377<i!\377""Ej$\377Mk&\377Pk\'\377Rk(\377[l*\377wo2\377\207q7\377\
\205q6\377so1\377""dm-\377Sk(\377""Ai#\377""6h \377""2h\37\377""1g\36\377""8h \
\377""Dj$\377Ij%\377Wl)\377|p4\377\211q7\377\212r8\377\212r8\377\211q7\377\
\205q6\377po0\377Zl*\377""Dj$\377:h!\377""5h\37\377""5h\37\377""8h \377@i#\
\377Jj%\377Uk(\377""bm,\377vo2\377\210q7\377\212r8\377\212r8\377\206q6\377ro1\
\377Sk(\377""6h \377""1g\36\377""1g\36\377""1g\36\377""3h\37\377""Dj$\377Yl*\
\377uo2\377\207q7\377\212r8\377\212r8\377\212r8\377\206q6\377vo2\377""am,\377Y\
l*\377Lj&\377?i\"\377""7h \377:h!\377>i\"\377""Ai#\377Jj%\377""em-\377|p4\377\
\207q7\377\212r8\377\212r8\377\210q7\377}p4\377kn/\377[l*\377""Ai#\377""3h\37\
\377""3h\37\377""3h\37\377""8h \377Ok\'\377uo2\377\207q7\377\212r8\377\212r8\
\377\212r8\377\212r8\377\177p4\377""fm-\377Yl*\377Wl)\377Wl)\377Sk(\377Kj&\
\377""Fj$\377Hj%\377Lj&\377Vl)\377ln/\377\207q7\377\212r8\377\212r8\377\210q7\
\377}p4\377jn.\377]l+\377Zl*\377Pk\'\377?i\"\377""7h \377""7h \377@i#\377Qk\'\
\377mn/\377\205q6\377\212r8\377\212r8\377\212r8\377\211q7\377qo0\377[l*\377Vl)\
\377Tk(\377Yl*\377nn0\377xp3\377`m,\377Vl)\377Wl)\377Yl*\377]l+\377so1\377\
\207q7\377\207q7\377yp3\377gn.\377]l+\377Zl*\377Zl*\377Xl)\377Qk\'\377Hj%\377H\
j%\377Ij%\377Jj%\377Rk(\377nn0\377\207q7\377\212r8\377\212r8\377\207q7\377gn.\
\377Yl*\377Qk\'\377Sk(\377_m+\377\202q5\377\210q7\377uo2\377""am,\377Zl*\377[l\
*\377\\l*\377`m,\377nn0\377po0\377""bm,\377\\l+\377\\l+\377[l*\377[l*\377""bm,\
\377so1\377in.\377Rk(\377Ij%\377Hj%\377Kj&\377]l+\377}p4\377\212r8\377\212r8\
\377\204q6\377""cm,\377Sk(\377Mk&\377Pk\'\377""dm-\377\210q7\377\212r8\377\
\207q7\377so1\377""am,\377\\l*\377]l+\377Uk(\377Ok\'\377Qk\'\377Yl*\377[l*\
\377\\l*\377^m+\377jn/\377}p4\377\210q7\377~p4\377Zl*\377Hj%\377""Ej$\377Hj%\
\377Tk(\377to1\377\212r8\377\212r8\377\204q6\377`m,\377Rk(\377Jj%\377Kj&\377[l\
*\377\205q6\377\211q7\377\212r8\377\207q7\377so1\377`m,\377Rk(\377Hj%\377""Ai#\
\377""Ci#\377Lj&\377Wl)\377`m,\377kn/\377}p4\377\210q7\377\212r8\377\207q7\
\377in.\377Kj&\377""Ej$\377Hj%\377Sk(\377nn0\377\212r8\377\212r8\377\207q7\
\377""bm,\377Sk(\377Nk&\377Kj&\377Mk&\377gn.\377{p3\377\207q7\377\212r8\377\
\205q6\377""em-\377Kj&\377""Bi#\377""Bi#\377@i#\377""Dj$\377Pk\'\377in.\377\
\177p5\377\210q7\377\212r8\377\212r8\377\212r8\377{p3\377Vl)\377Ij%\377Jj%\
\377Vl)\377mn/\377\212r8\377\212r8\377\211q7\377nn0\377Yl*\377Pk\'\377Kj&\377K\
j&\377Tk(\377""am,\377yp3\377\206q6\377uo2\377""bm,\377Nk\'\377""Fj$\377""Ai#\
\377""Ai#\377""Dj$\377Tk(\377nn0\377\205q6\377\212r8\377\212r8\377\212r8\377\
\212r8\377|p4\377Zl*\377Qk\'\377Rk(\377\\l*\377nn0\377\212r8\377\212r8\377\
\212r8\377\200p5\377in.\377Vl)\377Mk&\377Ok\'\377Rk(\377Rk(\377Zl*\377""bm,\
\377^m+\377^m+\377[l*\377Ok\'\377""Fj$\377Gj%\377Ok\'\377Yl*\377""bm,\377yp3\
\377\211q7\377\212r8\377\212r8\377\211q7\377so1\377Yl*\377Rk(\377Rk(\377\\l+\
\377uo2\377\212r8\377\212r8\377\212r8\377\210q7\377\201q5\377ln/\377Wl)\377Rk(\
\377Qk\'\377Jj%\377""Ci#\377""Bi#\377Hj%\377Vl)\377]l+\377]l+\377\\l*\377Vl)\
\377Tk(\377Nk\'\377Kj&\377Rk(\377""dm-\377hn.\377nn0\377yp3\377hn.\377Xl)\377R\
k(\377Sk(\377_m+\377\177p5\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\207q7\377ro1\377]l+\377Pk\'\377""Ej$\377=i\"\377:h!\377:h!\377>i\"\377Hj%\
\377Tk(\377]l+\377Lj&\377>i\"\377:h!\377;i!\377?i\"\377Kj&\377Tk(\377Rk(\377Rk\
(\377Kj&\377Nk\'\377Pk\'\377Uk(\377""dm-\377\206q6\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\207q7\377wo2\377]l+\377""Bi#\377:h!\
\377""9h \377""7h \377:h!\377""Fj$\377Qk\'\377Sk(\377Hj%\377""8h \377""4h\37\
\377""5h\37\377""8h \377=i\"\377Jj%\377Jj%\377""Ej$\377;i!\377?i\"\377""Fj$\
\377Uk(\377kn/\377\211q7\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\207q7\377kn/\377Hj%\377=i\"\377""8h \377:h!\377""Ai#\
\377Nk\'\377Ok\'\377Ok\'\377Kj&\377""9h!\377""3h\37\377""2h\37\377""3h\37\377""\
8h \377Hj%\377""Fj$\377@i\"\377;i!\377>i\"\377""Dj$\377Ul)\377ro1\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\203q6\377in.\377Tk(\377""Fj$\377@i\"\377""Dj$\377Qk\'\377Vl)\377Sk(\377Sk(\
\377Rk(\377""Ai#\377""6h \377""4h\37\377""7h \377=i\"\377Kj&\377Kj&\377""Dj$\
\377""Bi#\377""Ej$\377Jj%\377[l*\377zp3\377\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377{p3\377""bm,\377Xl)\377Tk(\377Rk(\
\377[l*\377gn.\377""dm-\377""dm-\377""dm-\377""cm-\377Pk\'\377@i#\377@i\"\377G\
j$\377Qk\'\377""em-\377""em-\377Rk(\377Nk\'\377Qk\'\377Yl*\377jn/\377\203q6\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377vo2\377^m+\377Tk(\377Qk\'\377Xl)\377ro1\377\211q7\377\212r8\377\212r\
8\377\212r8\377\212r8\377on0\377Pk\'\377Ij%\377Kj&\377Vl)\377ro1\377\207q7\
\377zp3\377jn/\377""em-\377nn0\377~p4\377\210q7\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377wo2\377_m+\377Tk(\377Pk\
\'\377Yl*\377so1\377\211q7\377\212r8\377\212r8\377\212r8\377\211q7\377nn0\377S\
k(\377Jj%\377Lj&\377Zl*\377xo2\377\212r8\377\211q7\377\207q7\377\207q7\377\
\207q7\377\211q7\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377{p3\377""bm,\377Wl)\377Qk\'\377Qk\'\377`m,\
\377xo2\377\200p5\377\201q5\377\200p5\377zp3\377[l*\377Mk&\377Lj&\377Tk(\377""\
am,\377\200p5\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\203q6\377jn.\377[l*\377Rk(\377Mk&\377Lj&\377Sk(\377[l*\377`m,\
\377_m+\377Wl)\377Lj&\377Kj&\377Mk&\377Tk(\377hn.\377\206q6\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\210q7\377vo2\377""\
cm,\377Sk(\377Nk&\377Kj&\377Jj%\377Lj&\377Sk(\377Sk(\377Mk&\377Jj%\377Lj&\377P\
k\'\377Yl*\377uo2\377\211q7\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\205q6\377to1\377Zl*\377Qk\'\377Nk&\
\377Kj&\377Jj%\377Pk\'\377Rk(\377Ok\'\377Ok\'\377Rk(\377Yl*\377gn.\377\202q5\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\211q7\377\205q6\377on0\377]l+\377Vl)\377Sk(\377Rk(\
\377Vl)\377Yl*\377Zl*\377Yl*\377]l+\377jn.\377}p4\377\210q7\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\206q7\377yp3\377ln/\377gn.\377in.\377in.\377jn/\377on\
0\377uo2\377~p4\377\205q6\377\211q7\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377";
static Fl_RGB_Image image_fancysolidground(idata_fancysolidground, 32, 48, 4, 0);

Fl_Round_Button *rb04=(Fl_Round_Button *)0;

static void cb_rb04(Fl_Round_Button*, void*) {
  tile=M_TREE;
}

static unsigned char idata_tree[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\345\273W\377\345\273W\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_tree(idata_tree, 32, 48, 4, 0);

Fl_Round_Button *rb05=(Fl_Round_Button *)0;

static void cb_rb05(Fl_Round_Button*, void*) {
  tile=M_FENCE;
}

static unsigned char idata_fence[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\
\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\
\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\345\273W\377\345\273W\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\345\273W\
\377\345\273W\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\
\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\
\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\
\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\
\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\377\377\377\377\
\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_fence(idata_fence, 32, 48, 4, 0);

Fl_Round_Button *rb06=(Fl_Round_Button *)0;

static void cb_rb06(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL;
}

static unsigned char idata_TL[] =
"\0\0\0\0\212r8j\212r8x\212r8D\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\301\323\
\325\205\301\323\325U\301\323\325""F\301\323\325[\301\323\325\221\301\323\325\
\312\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\301\323\325\377\0\0\0\0\0\0\0\0\0\0\0\0\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\0\0\0\0\0\0\0\0\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\301\323\325\377\301\323\325\377\0\0\0\0\0\0\0\0\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\306\326\330\377\314\333\334\377\317\335\336\
\377\314\333\334\377\306\326\330\377\301\323\325\377\301\323\325\377\0\0\0\0\
\0\0\0\0\301\323\325\315\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\306\326\330\377\320\335\337\377\321\336\340\377\
\322\337\340\377\321\336\340\377\320\335\337\377\306\326\330\377\301\323\325\
\377\0\0\0\0\0\0\0\0\301\323\325N\301\323\325\315\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\315\334\335\377\322\337\340\377\322\337\
\340\377\322\337\340\377\322\337\340\377\322\337\340\377\315\334\335\377\301\
\323\325\377\0\0\0\0\0\0\0\0\301\323\325\25\301\323\325\225\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\321\336\340\377\322\337\340\
\377\322\337\340\377\322\337\340\377\322\337\340\377\322\337\340\377\321\336\
\340\377\301\323\325\377\0\0\0\0\0\0\0\0\0\0\0\0\301\323\325\200\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\320\335\337\377\322\337\
\340\377\322\337\340\377\322\337\340\377\322\337\340\377\322\337\340\377\320\
\335\337\377\301\323\325\377\0\0\0\0\0\0\0\0\301\323\325\25\301\323\325\225\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\311\331\332\
\377\322\337\340\377\322\337\340\377\322\337\340\377\322\337\340\377\322\337\
\340\377\311\331\332\377\301\323\325\377\0\0\0\0\0\0\0\0\301\323\325N\301\323\
\325\315\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\302\
\324\325\377\311\331\333\377\320\335\337\377\322\337\340\377\320\335\337\377\
\311\331\333\377\302\324\325\377\301\323\325\377\0\0\0\0\0\0\0\0\301\323\325\
\315\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\302\324\325\377\303\325\326\377\304\325\327\377\303\
\325\326\377\302\324\325\377\301\323\325\377\301\323\325\377\0\0\0\0\0\0\0\0\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\0\0\
\0\0\0\0\0\0\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377";
static Fl_RGB_Image image_TL(idata_TL, 16, 16, 4, 0);

Fl_Round_Button *rb07=(Fl_Round_Button *)0;

static void cb_rb07(Fl_Round_Button*, void*) {
  tile=M_DECORATION1;
}

static unsigned char idata_deco1[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0";
static Fl_RGB_Image image_deco1(idata_deco1, 48, 48, 4, 0);

Fl_Round_Button *rb08=(Fl_Round_Button *)0;

static void cb_rb08(Fl_Round_Button*, void*) {
  tile=M_DECORATION2;
}

static unsigned char idata_deco2[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!\
f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!\
f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\
\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\377!f\32\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_deco2(idata_deco2, 48, 48, 4, 0);

Fl_Round_Button *rb09=(Fl_Round_Button *)0;

static void cb_rb09(Fl_Round_Button*, void*) {
  tile=M_SLIPPERYL;
}

static unsigned char idata_slipL[] =
"\325\315\270\377\307\273\237\377\231\204R\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\350\343\330\377\326\316\272\377\256\236v\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\363\361\354\377\350\343\
\327\377\301\264\226\377\212r8\377\212r8\377\212r8\377\213s8\377\214t8\377\
\214t8\377\213s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\366\364\360\377\360\355\346\377\312\300\246\377\212r8\377\212r8\377\215u9\
\377\223y;\377\226|<\377\226|<\377\223y;\377\215u9\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\366\365\361\377\363\360\352\377\315\303\253\
\377\212s9\377\215t9\377\223z;\377\227|<\377\227|<\377\227|<\377\227|<\377\
\223z;\377\215t9\377\212r8\377\212r8\377\212r8\377\212r8\377\365\363\357\377\
\357\353\343\377\314\301\250\377\216w?\377\220v:\377\226|<\377\227|<\377\227|<\
\377\227|<\377\227|<\377\226|<\377\220v:\377\212r8\377\212r8\377\212r8\377\
\212r8\377\361\356\350\377\343\336\320\377\307\273\240\377\220yB\377\220w:\
\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\220w:\377\
\212r8\377\212r8\377\212r8\377\212r8\377\353\347\336\377\322\311\264\377\273\
\255\213\377\222zB\377\224{;\377\235\202>\377\237\202>\377\234\200>\377\230}<\
\377\227|<\377\225{<\377\216v9\377\212r8\377\212r8\377\212r8\377\212r8\377\
\354\350\337\377\321\307\260\377\253\230m\377\226}A\377\230|<\377\236\201>\
\377\241\205?\377\241\204?\377\236\201>\377\227}<\377\222x:\377\214s8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\356\353\342\377\322\311\264\377\234\207Q\
\377\225|=\377\227|<\377\231}<\377\234\201>\377\237\203?\377\235\202>\377\224z\
;\377\214s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\360\355\346\
\377\325\315\270\377\226\177""F\377\227|<\377\227|<\377\227|<\377\227|<\377\
\227|<\377\227|<\377\220w:\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\363\360\352\377\335\326\306\377\230\200I\377\226|<\377\227|<\
\377\227|<\377\227|<\377\227|<\377\226|<\377\220v:\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\365\363\357\377\342\334\315\377\231\
\203O\377\223z;\377\227|<\377\227|<\377\227|<\377\227|<\377\223z;\377\215t9\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\363\361\354\
\377\336\327\307\377\230\203P\377\215u9\377\223y;\377\226|<\377\226|<\377\223y\
;\377\215u9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\355\351\341\377\320\307\260\377\225\177K\377\212r8\377\213s8\377\
\214t8\377\214t8\377\213s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\332\322\300\377\266\247\203\377\222{F\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\217xA\377";
static Fl_RGB_Image image_slipL(idata_slipL, 16, 16, 4, 0);

Fl_Round_Button *rb10=(Fl_Round_Button *)0;

static void cb_rb10(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+1;
}

Fl_Round_Button *rb11=(Fl_Round_Button *)0;

static void cb_rb11(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+16;
}

Fl_Round_Button *rb12=(Fl_Round_Button *)0;

static void cb_rb12(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+17;
}

Fl_Round_Button *rb13=(Fl_Round_Button *)0;

static void cb_rb13(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+32;
}

Fl_Round_Button *rb14=(Fl_Round_Button *)0;

static void cb_rb14(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+33;
}

Fl_Round_Button *rb15=(Fl_Round_Button *)0;

static void cb_rb15(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+2;
}

Fl_Round_Button *rb16=(Fl_Round_Button *)0;

static void cb_rb16(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+18;
}

Fl_Round_Button *rb17=(Fl_Round_Button *)0;

static void cb_rb17(Fl_Round_Button*, void*) {
  tile=M_PLATFORMTL+34;
}

Fl_Round_Button *rb18=(Fl_Round_Button *)0;

static void cb_rb18(Fl_Round_Button*, void*) {
  tile=M_SLIPPERYR;
}

static unsigned char idata_slipR[] =
"\271\252\210\377\236\212[\377\216v?\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\217xA\377\242\217""b\377\235\211X\377\216v?\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\234\210W\377\277\262\223\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\216v?\377\265\246\202\377\337\331\311\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\216v?\377\240\215_\377\315\303\253\
\377\354\350\337\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\214s8\377\224z;\377\234\200>\377\235\202>\377\231~=\377\220w:\377\222{F\
\377\266\250\204\377\330\320\274\377\363\361\353\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\214s8\377\225z;\377\240\204?\377\242\205@\377\242\
\206@\377\241\205@\377\235\201>\377\231\202J\377\304\270\233\377\335\326\305\
\377\363\361\353\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\216u9\
\377\235\202>\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\241\205@\
\377\240\207J\377\305\271\235\377\337\331\311\377\363\361\353\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\216v9\377\242\205@\377\242\206@\377\
\242\206@\377\242\206@\377\242\206@\377\242\206@\377\240\206""D\377\271\252\
\210\377\342\334\315\377\365\363\356\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\216u9\377\240\204?\377\242\206@\377\242\206@\377\242\206@\377\
\242\206@\377\242\205@\377\234\200>\377\240\214]\377\332\323\301\377\366\364\
\360\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\214s8\377\230~=\
\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\240\204?\377\224z;\
\377\226\200M\377\327\316\273\377\365\363\356\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\216u9\377\230~=\377\240\204?\377\242\205@\
\377\235\202>\377\225z;\377\214s8\377\241\216_\377\337\331\311\377\370\367\
\364\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\214s8\377\216u9\377\216v9\377\216u9\377\214s8\377\212r8\377\252\231o\377\
\343\335\317\377\372\371\367\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\252\231o\377\335\326\306\377\373\372\370\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\241\216_\377\321\307\260\377\370\367\364\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\221{E\377\263\
\243~\377\351\345\332\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\221{E\377\257\236w\377";
static Fl_RGB_Image image_slipR(idata_slipR, 16, 16, 4, 0);

Fl_Round_Button *rb19=(Fl_Round_Button *)0;

static void cb_rb19(Fl_Round_Button*, void*) {
  tile=M_SLIPPERYT;
}

static unsigned char idata_slipT[] =
"\343\335\320\377\350\343\330\377\354\350\337\377\353\347\336\377\352\346\335\
\377\360\355\346\377\357\354\345\377\356\353\343\377\361\356\350\377\365\363\
\356\377\365\363\357\377\364\362\355\377\361\356\347\377\352\346\334\377\330\
\320\275\377\275\257\217\377\334\325\305\377\342\333\315\377\342\334\316\377\
\322\311\263\377\304\267\231\377\307\271\227\377\334\323\273\377\350\341\322\
\377\353\346\332\377\355\351\340\377\360\355\346\377\362\357\351\377\360\355\
\346\377\344\337\322\377\310\275\242\377\254\233r\377\310\274\242\377\305\272\
\236\377\265\246\202\377\244\217_\377\243\213P\377\247\214L\377\277\254}\377\
\325\307\250\377\335\323\273\377\337\327\302\377\342\334\315\377\347\342\326\
\377\342\334\315\377\311\276\244\377\247\225j\377\223}H\377\212r8\377\212r8\
\377\212r8\377\223y;\377\240\203?\377\243\207""B\377\253\222S\377\276\252y\
\377\314\275\227\377\322\305\245\377\313\277\241\377\275\260\220\377\244\222""\
e\377\216w?\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\226|<\377\
\242\205@\377\242\206@\377\243\207""B\377\252\220Q\377\264\236""f\377\271\244p\
\377\255\231h\377\232\205T\377\216w?\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\225{<\377\241\204?\377\242\206@\377\242\206@\377\242\
\206@\377\244\210@\377\244\207@\377\231~=\377\215t9\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\220w:\377\234\201>\377\242\
\206@\377\242\206@\377\247\212""A\377\256\220""D\377\256\217""D\377\245\210""A\
\377\233\200=\377\221x:\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\221x:\377\233\200=\377\245\207@\377\257\217""C\377\257\
\220""D\377\250\212""A\377\242\206@\377\242\206@\377\234\201>\377\220w:\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\215t9\
\377\231~<\377\244\207@\377\245\207""A\377\242\206@\377\242\206@\377\242\206@\
\377\241\204?\377\225{<\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\226|<\377\242\205@\377\242\206@\377\242\206@\
\377\242\206@\377\242\206@\377\242\205@\377\226|<\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\223y;\377\240\203?\
\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\240\203?\377\223y;\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\216u9\377\231~=\377\241\204?\377\242\205@\377\242\205@\377\241\204?\
\377\231~=\377\216u9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\216u9\377\227|<\377\234\201>\377\234\
\201>\377\227|<\377\216u9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377";
static Fl_RGB_Image image_slipT(idata_slipT, 16, 16, 4, 0);

Fl_Round_Button *rb20=(Fl_Round_Button *)0;

static void cb_rb20(Fl_Round_Button*, void*) {
  tile=M_BIRDRIGHT1;
}

static unsigned char idata_bird[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_bird(idata_bird, 16, 16, 4, 0);

Fl_Round_Button *rb21=(Fl_Round_Button *)0;

static void cb_rb21(Fl_Round_Button*, void*) {
  tile=M_CHICKRIGHT1;
}

static unsigned char idata_chick[] =
"\345\273W\2\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\371\373@2\371\373@\234\371\373@\356\371\373@\367\371\373@\367\371\373@\
\356\371\373@\234\371\373@2\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\371\373@2\371\373@\261\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\261\371\373@2\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\371\373@j\371\373@\352\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\352\371\373@j\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\177\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\177\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@j\
\371\373@\352\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\352\371\373@j\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\371\373@Z\371\373@\321\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\261\371\373@2\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@2\371\373@\261\371\373@\356\371\373@\377\
\371\373@\376\371\373@\375\371\373@\371\371\373@\356\371\373@\235\371\373@2\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\234\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\234\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\352\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\352\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\352\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\352\0\0\0\0\345\273W\2\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\371\373@\234\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\234\0\0\0\0\0\0\0\0\345\273W\3\345\273W\1\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\371\373@2\371\373@\261\371\373@\352\371\373@\377\371\373@\
\352\371\373@\261\371\373@2\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\2\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@2\371\373@k\371\373@\200\371\373@k\
\371\373@2\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\1\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_chick(idata_chick, 16, 16, 4, 0);

Fl_Round_Button *rb22=(Fl_Round_Button *)0;

static void cb_rb22(Fl_Round_Button*, void*) {
  tile=M_CHEST1;
}

static unsigned char idata_chest[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@^\371\373@\
\264\371\373@\351\371\373@\374\371\373@\351\371\373@\264\371\373@=\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\371\373@4\371\373@\307\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\374\371\373@\225\
\371\373@4\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\371\373@H\371\373@\366\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\366\371\373@H\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\371\373@,\371\373@\362\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\362\371\373@,\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\277\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\371\373@b\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\371\373@\377\371\373@\377\371\373@\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@7\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\371\373@7\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\371\373@\177\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\371\373@\177\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\266\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\371\373@\266\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\336\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\371\373@\336\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\365\
\371\373@\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\371\373@\377\371\373@\365\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\371\373@\376\371\373@\377\371\373@\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\371\373@\377\371\373@\376\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\371\373@\365\371\373@\377\371\373@\377\371\373@\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\371\373@\377\371\373@\377\371\373@\365\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\371\373@\336\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\336\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\371\373@\266\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\266\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\177\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\177\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@7\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@7\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\371\373@\315\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\315\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@b\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@b\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\371\373@\277\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\277\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@1\371\373@\366\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\362\371\373@,\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@C\371\373@\245\371\373@\371\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\373\371\373@\245\371\373@C\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@8\371\
\373@\270\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\270\371\373@8\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@~\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@~\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\371\373@\241\371\373@\377\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\241\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\371\373@\234\371\373@\377\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\234\0\0\0\0\0\0\0\0\0\0\0\0\371\373@l\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@l\0\0\0\0\371\373@\n\371\373@\355\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\355\371\373@\n\371\373@r\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@r\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_chest(idata_chest, 32, 32, 4, 0);

Fl_Round_Button *rb23=(Fl_Round_Button *)0;

static void cb_rb23(Fl_Round_Button*, void*) {
  tile=M_CHECKPOINT;
}

static unsigned char idata_checkpoint[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\365\371\373@\340\371\373@\
\301\371\373@\257\371\373@\264\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_checkpoint(idata_checkpoint, 16, 32, 4, 0);

Fl_Round_Button *rb24=(Fl_Round_Button *)0;

static void cb_rb24(Fl_Round_Button*, void*) {
  tile=M_WALLCLIMBERLEFT;
}

static unsigned char idata_crawlerleft[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\
\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\
\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0";
static Fl_RGB_Image image_crawlerleft(idata_crawlerleft, 16, 32, 4, 0);

Fl_Round_Button *rb25=(Fl_Round_Button *)0;

static void cb_rb25(Fl_Round_Button*, void*) {
  tile=M_WALLCLIMBERRIGHT;
}

static unsigned char idata_crawlerright[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\
\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\
\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\
\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_crawlerright(idata_crawlerright, 16, 32, 4, 0);

Fl_Round_Button *rb26=(Fl_Round_Button *)0;

static void cb_rb26(Fl_Round_Button*, void*) {
  tile=M_FANCYSKY;
}

static unsigned char idata_cloud[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\377\377\13\377\377\377""4\377\377\377M\377\377\377J\377\377\377$\
\377\377\377\17\377\377\377\2\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\1\377\377\
\377\6\377\377\377\7\377\377\377\6\377\377\377\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377""8\377\377\377""f\377\377\377\
\202\377\377\377\222\377\377\377\201\377\377\377H\377\377\377\26\0\0\0\0\0\0\
\0\0\377\377\377\6\377\377\377\'\377\377\377""B\377\377\377L\377\377\377@\377\
\377\377.\377\377\377\30\377\377\377\t\377\377\377\1\377\377\377\b\377\377\
\377*\377\377\377M\377\377\377""c\377\377\377U\377\377\377""2\377\377\377\16\
\377\377\377\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\1\377\377\377\20\
\377\377\377{\377\377\377\227\377\377\377\251\377\377\377\242\377\377\377\231\
\377\377\377^\377\377\377:\377\377\377\4\377\377\377\30\377\377\377@\377\377\
\377\\\377\377\377`\377\377\377l\377\377\377w\377\377\377o\377\377\377Z\377\
\377\377>\377\377\377\35\377\377\377?\377\377\377k\377\377\377\214\377\377\
\377\230\377\377\377\221\377\377\377n\377\377\377:\377\377\377\6\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\377\377\377\t\377\377\377""C\377\377\377\223\377\377\377\
\250\377\377\377\273\377\377\377\261\377\377\377\227\377\377\377`\377\377\377Q\
\377\377\377""B\377\377\377""b\377\377\377u\377\377\377w\377\377\377z\377\377\
\377~\377\377\377\211\377\377\377\202\377\377\377t\377\377\377""d\377\377\377^\
\377\377\377z\377\377\377\212\377\377\377\253\377\377\377\262\377\377\377\254\
\377\377\377\214\377\377\377""b\377\377\377\16\0\0\0\0\0\0\0\0\0\0\0\0\377\
\377\377\4\377\377\377,\377\377\377\177\377\377\377\230\377\377\377\253\377\
\377\377\272\377\377\377\263\377\377\377|\377\377\377""f\377\377\377k\377\377\
\377s\377\377\377\203\377\377\377\221\377\377\377\226\377\377\377\222\377\377\
\377\205\377\377\377\207\377\377\377\203\377\377\377|\377\377\377}\377\377\
\377\224\377\377\377\240\377\377\377\232\377\377\377\270\377\377\377\303\377\
\377\377\266\377\377\377\233\377\377\377r\377\377\377\24\0\0\0\0\0\0\0\0\377\
\377\377\37\377\377\377K\377\377\377\177\377\377\377\255\377\377\377\265\377\
\377\377\272\377\377\377\254\377\377\377\214\377\377\377Y\377\377\377""a\377\
\377\377h\377\377\377\211\377\377\377\243\377\377\377\256\377\377\377\265\377\
\377\377\256\377\377\377\217\377\377\377w\377\377\377w\377\377\377\177\377\
\377\377\225\377\377\377\263\377\377\377\270\377\377\377\261\377\377\377\276\
\377\377\377\305\377\377\377\265\377\377\377\232\377\377\377s\377\377\377&\
\377\377\377\23\377\377\377\b\377\377\377O\377\377\377x\377\377\377\252\377\
\377\377\304\377\377\377\320\377\377\377\317\377\377\377\270\377\377\377\177\
\377\377\377t\377\377\377u\377\377\377v\377\377\377\237\377\377\377\271\377\
\377\377\301\377\377\377\275\377\377\377\265\377\377\377\220\377\377\377j\377\
\377\377Q\377\377\377q\377\377\377\253\377\377\377\272\377\377\377\303\377\
\377\377\275\377\377\377\272\377\377\377\235\377\377\377\225\377\377\377\224\
\377\377\377\231\377\377\377{\377\377\377h\377\377\377""6\377\377\377o\377\
\377\377\212\377\377\377\276\377\377\377\323\377\377\377\323\377\377\377\316\
\377\377\377\304\377\377\377\252\377\377\377\262\377\377\377\263\377\377\377\
\267\377\377\377\300\377\377\377\300\377\377\377\277\377\377\377\275\377\377\
\377\264\377\377\377\242\377\377\377\213\377\377\377""D\377\377\377M\377\377\
\377\255\377\377\377\302\377\377\377\306\377\377\377\304\377\377\377\301\377\
\377\377\222\377\377\377\215\377\377\377\252\377\377\377\264\377\377\377\237\
\377\377\377\226\377\377\377|\377\377\377\207\377\377\377\221\377\377\377\301\
\377\377\377\327\377\377\377\320\377\377\377\313\377\377\377\314\377\377\377\
\275\377\377\377\303\377\377\377\322\377\377\377\334\377\377\377\321\377\377\
\377\277\377\377\377\305\377\377\377\312\377\377\377\274\377\377\377\260\377\
\377\377\244\377\377\377n\377\377\377R\377\377\377\237\377\377\377\303\377\
\377\377\311\377\377\377\322\377\377\377\315\377\377\377\263\377\377\377\244\
\377\377\377\306\377\377\377\313\377\377\377\306\377\377\377\277\377\377\377\
\247\377\377\377\254\377\377\377\256\377\377\377\275\377\377\377\305\377\377\
\377\300\377\377\377\302\377\377\377\306\377\377\377\300\377\377\377\323\377\
\377\377\344\377\377\377\350\377\377\377\326\377\377\377\301\377\377\377\302\
\377\377\377\313\377\377\377\320\377\377\377\307\377\377\377\260\377\377\377\
\206\377\377\377g\377\377\377\205\377\377\377\301\377\377\377\323\377\377\377\
\333\377\377\377\314\377\377\377\311\377\377\377\322\377\377\377\327\377\377\
\377\321\377\377\377\323\377\377\377\324\377\377\377\271\377\377\377\247\377\
\377\377\261\377\377\377\275\377\377\377\237\377\377\377\237\377\377\377\260\
\377\377\377\272\377\377\377\310\377\377\377\336\377\377\377\350\377\377\377\
\350\377\377\377\335\377\377\377\304\377\377\377\251\377\377\377\260\377\377\
\377\321\377\377\377\325\377\377\377\312\377\377\377\261\377\377\377\232\377\
\377\377\232\377\377\377\270\377\377\377\315\377\377\377\337\377\377\377\332\
\377\377\377\332\377\377\377\344\377\377\377\332\377\377\377\320\377\377\377\
\335\377\377\377\325\377\377\377\260\377\377\377\242\377\377\377\254\377\377\
\377\276\377\377\377\244\377\377\377\245\377\377\377\235\377\377\377\247\377\
\377\377\313\377\377\377\335\377\377\377\336\377\377\377\340\377\377\377\336\
\377\377\377\301\377\377\377\232\377\377\377\261\377\377\377\316\377\377\377\
\324\377\377\377\317\377\377\377\277\377\377\377\246\377\377\377\277\377\377\
\377\316\377\377\377\332\377\377\377\355\377\377\377\360\377\377\377\353\377\
\377\377\350\377\377\377\326\377\377\377\302\377\377\377\317\377\377\377\306\
\377\377\377\263\377\377\377\235\377\377\377\247\377\377\377\243\377\377\377\
\255\377\377\377\300\377\377\377\265\377\377\377\250\377\377\377\276\377\377\
\377\313\377\377\377\311\377\377\377\316\377\377\377\310\377\377\377\266\377\
\377\377\263\377\377\377\301\377\377\377\307\377\377\377\314\377\377\377\312\
\377\377\377\274\377\377\377\241\377\377\377\314\377\377\377\327\377\377\377\
\341\377\377\377\365\377\377\377\370\377\377\377\364\377\377\377\353\377\377\
\377\330\377\377\377\263\377\377\377\300\377\377\377\264\377\377\377\254\377\
\377\377\207\377\377\377\216\377\377\377\217\377\377\377\252\377\377\377\275\
\377\377\377\276\377\377\377\260\377\377\377\242\377\377\377\263\377\377\377\
\270\377\377\377\265\377\377\377\231\377\377\377\225\377\377\377\241\377\377\
\377\262\377\377\377\267\377\377\377\273\377\377\377\265\377\377\377\244\377\
\377\377\221\377\377\377\301\377\377\377\325\377\377\377\342\377\377\377\363\
\377\377\377\367\377\377\377\362\377\377\377\354\377\377\377\322\377\377\377\
\204\377\377\377\221\377\377\377\237\377\377\377\243\377\377\377\'\377\377\
\377S\377\377\377\225\377\377\377\235\377\377\377\253\377\377\377\270\377\377\
\377\263\377\377\377\201\377\377\377}\377\377\377\215\377\377\377\236\377\377\
\377\246\377\377\377\266\377\377\377\275\377\377\377\270\377\377\377\245\377\
\377\377\223\377\377\377\204\377\377\377q\377\377\377r\377\377\377\236\377\
\377\377\276\377\377\377\327\377\377\377\353\377\377\377\357\377\377\377\353\
\377\377\377\343\377\377\377\266\377\377\377U\377\377\377\202\377\377\377\232\
\377\377\377\232\377\377\377\3\377\377\377\24\377\377\377\205\377\377\377\244\
\377\377\377\244\377\377\377\235\377\377\377\214\377\377\377P\377\377\377""a\
\377\377\377o\377\377\377\213\377\377\377\257\377\377\377\300\377\377\377\302\
\377\377\377\310\377\377\377\301\377\377\377\227\377\377\377I\377\377\377\24\
\377\377\377!\377\377\377M\377\377\377\215\377\377\377\270\377\377\377\330\
\377\377\377\342\377\377\377\340\377\377\377\311\377\377\377\204\377\377\377@\
\377\377\377~\377\377\377\230\377\377\377\227\0\0\0\0\0\0\0\0\377\377\377k\
\377\377\377\233\377\377\377\247\377\377\377\233\377\377\377q\377\377\377""3\
\377\377\377\\\377\377\377p\377\377\377|\377\377\377\242\377\377\377\262\377\
\377\377\304\377\377\377\306\377\377\377\277\377\377\377\256\377\377\377\221\
\377\377\377G\377\377\377\r\377\377\377\b\377\377\377\33\377\377\377P\377\377\
\377\245\377\377\377\274\377\377\377\270\377\377\377\233\377\377\377u\377\377\
\377\203\377\377\377\254\377\377\377\251\377\377\377\211\377\377\377\1\377\
\377\377\13\377\377\377}\377\377\377\230\377\377\377\230\377\377\377\215\377\
\377\377\211\377\377\377_\377\377\377p\377\377\377v\377\377\377\202\377\377\
\377\241\377\377\377\267\377\377\377\322\377\377\377\326\377\377\377\324\377\
\377\377\312\377\377\377\312\377\377\377\257\377\377\377\201\377\377\377""6\
\377\377\377\24\377\377\377/\377\377\377v\377\377\377\210\377\377\377\207\377\
\377\377z\377\377\377\230\377\377\377\243\377\377\377\252\377\377\377\253\377\
\377\377\236\377\377\377\t\377\377\377/\377\377\377\205\377\377\377\230\377\
\377\377\231\377\377\377\242\377\377\377\240\377\377\377v\377\377\377r\377\
\377\377u\377\377\377\214\377\377\377\257\377\377\377\305\377\377\377\332\377\
\377\377\342\377\377\377\344\377\377\377\336\377\377\377\327\377\377\377\306\
\377\377\377\300\377\377\377\236\377\377\377{\377\377\377u\377\377\377~\377\
\377\377\204\377\377\377\222\377\377\377\247\377\377\377\275\377\377\377\265\
\377\377\377\252\377\377\377\245\377\377\377\230\377\377\377\35\377\377\377""f\
\377\377\377\223\377\377\377\244\377\377\377\257\377\377\377\265\377\377\377\
\244\377\377\377\214\377\377\377\202\377\377\377t\377\377\377\224\377\377\377\
\256\377\377\377\300\377\377\377\313\377\377\377\330\377\377\377\345\377\377\
\377\345\377\377\377\337\377\377\377\325\377\377\377\312\377\377\377\274\377\
\377\377\275\377\377\377\267\377\377\377\226\377\377\377\206\377\377\377\241\
\377\377\377\245\377\377\377\254\377\377\377\270\377\377\377\262\377\377\377\
\231\377\377\377m\377\377\377""D\377\377\377\203\377\377\377\226\377\377\377\
\250\377\377\377\272\377\377\377\252\377\377\377\235\377\377\377\245\377\377\
\377\237\377\377\377\202\377\377\377\252\377\377\377\301\377\377\377\314\377\
\377\377\321\377\377\377\321\377\377\377\314\377\377\377\324\377\377\377\335\
\377\377\377\336\377\377\377\333\377\377\377\324\377\377\377\316\377\377\377\
\302\377\377\377\264\377\377\377\245\377\377\377\246\377\377\377\212\377\377\
\377\207\377\377\377\250\377\377\377\247\377\377\377m\377\377\377\36\377\377\
\377""a\377\377\377\232\377\377\377\265\377\377\377\300\377\377\377\300\377\
\377\377\230\377\377\377\231\377\377\377\253\377\377\377\263\377\377\377\275\
\377\377\377\314\377\377\377\316\377\377\377\317\377\377\377\317\377\377\377\
\276\377\377\377\245\377\377\377\245\377\377\377\275\377\377\377\317\377\377\
\377\333\377\377\377\337\377\377\377\331\377\377\377\314\377\377\377\274\377\
\377\377\266\377\377\377\271\377\377\377\260\377\377\377\226\377\377\377{\377\
\377\377I\377\377\377\5\0\0\0\0\377\377\377l\377\377\377\245\377\377\377\267\
\377\377\377\304\377\377\377\304\377\377\377\244\377\377\377\227\377\377\377\
\250\377\377\377\275\377\377\377\326\377\377\377\332\377\377\377\330\377\377\
\377\313\377\377\377\244\377\377\377""f\377\377\377_\377\377\377r\377\377\377|\
\377\377\377\222\377\377\377\303\377\377\377\334\377\377\377\334\377\377\377\
\334\377\377\377\333\377\377\377\323\377\377\377\323\377\377\377\331\377\377\
\377\323\377\377\377\252\377\377\377""E\377\377\377\13\0\0\0\0\377\377\377U\
\377\377\377\236\377\377\377\265\377\377\377\266\377\377\377\263\377\377\377\
\247\377\377\377\250\377\377\377\270\377\377\377\312\377\377\377\330\377\377\
\377\330\377\377\377\324\377\377\377\274\377\377\377u\377\377\377\17\377\377\
\377\24\377\377\377""F\377\377\377""f\377\377\377r\377\377\377\250\377\377\
\377\275\377\377\377\316\377\377\377\341\377\377\377\341\377\377\377\331\377\
\377\377\341\377\377\377\345\377\377\377\336\377\377\377\315\377\377\377\214\
\377\377\377""3\0\0\0\0\377\377\377""2\377\377\377}\377\377\377\235\377\377\
\377\240\377\377\377\237\377\377\377\224\377\377\377\235\377\377\377\264\377\
\377\377\306\377\377\377\316\377\377\377\320\377\377\377\301\377\377\377\225\
\377\377\377I\377\377\377\1\0\0\0\0\377\377\377\6\377\377\377\'\377\377\377M\
\377\377\377\231\377\377\377\250\377\377\377\257\377\377\377\312\377\377\377\
\326\377\377\377\331\377\377\377\347\377\377\377\353\377\377\377\336\377\377\
\377\320\377\377\377\255\377\377\377W\0\0\0\0\377\377\377\13\377\377\377""E\
\377\377\377|\377\377\377\213\377\377\377\213\377\377\377\206\377\377\377\210\
\377\377\377\220\377\377\377\253\377\377\377\267\377\377\377\260\377\377\377\
\213\377\377\377[\377\377\377\"\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\1\377\377\
\377\t\377\377\377K\377\377\377\202\377\377\377\226\377\377\377\257\377\377\
\377\262\377\377\377\276\377\377\377\337\377\377\377\347\377\377\377\326\377\
\377\377\303\377\377\377\250\377\377\377W\0\0\0\0\0\0\0\0\377\377\377\5\377\
\377\377\32\377\377\377>\377\377\377g\377\377\377r\377\377\377p\377\377\377u\
\377\377\377v\377\377\377""f\377\377\377Y\377\377\377@\377\377\377\"\377\377\
\377\6\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\13\377\377\377@\
\377\377\377`\377\377\377u\377\377\377\203\377\377\377\207\377\377\377\236\
\377\377\377\265\377\377\377\275\377\377\377\252\377\377\377~\377\377\377""0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\3\377\377\377#\377\377\377G\377\
\377\377\\\377\377\377Z\377\377\377""A\377\377\377\30\377\377\377\3\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\3\
\377\377\377\17\377\377\377\33\377\377\377 \377\377\377\27\377\377\377\31\377\
\377\377""9\377\377\377\\\377\377\377Z\377\377\377""2\377\377\377\n\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\3\377\377\377\17\377\377\377\31\
\377\377\377\25\377\377\377\t\377\377\377\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0";
static Fl_RGB_Image image_cloud(idata_cloud, 32, 48, 4, 0);

Fl_Round_Button *rb27=(Fl_Round_Button *)0;

static void cb_rb27(Fl_Round_Button*, void*) {
  tile=M_EXIT;
}

static unsigned char idata_exit[] =
"\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\377\377\377\377\377\377\377\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\377\377\377\377\377\377\377\377\373@@\377\373@@\
\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\377\377\377\377\377\
\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\377\377\377\377\377\
\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\375\276\276\
\377\376\376\376\377\374uu\377\373@@\377\374uu\377\376\376\376\377\375\276\
\276\377\373@@\377\377\377\377\377\377\377\377\377\373@@\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373NN\377\376\355\355\377\376\355\355\377\373__\377\376\
\355\355\377\376\355\355\377\373NN\377\373@@\377\377\377\377\377\377\377\377\
\377\373@@\377\373@@\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\374yy\377\
\377\377\377\377\376\371\371\377\377\377\377\377\374yy\377\373@@\377\373@@\
\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\377\377\377\377\377\
\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\377\377\377\377\377\
\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\376\341\341\377\377\377\377\377\376\343\343\377\373@@\377\373@@\377\373@@\
\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\377\377\377\377\377\
\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\377\377\377\377\377\
\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\374\
\207\207\377\377\377\377\377\376\356\356\377\377\377\377\377\374\212\212\377\
\373@@\377\373@@\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\377\
\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\377\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373QQ\377\376\362\362\377\376\346\346\377\373QQ\377\376\344\344\377\376\
\363\363\377\373RR\377\373@@\377\377\377\377\377\377\377\377\377\373@@\377\
\373@@\377\376\364\364\377\377\377\377\377\373YY\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\373@@\377\375\301\301\377\376\375\375\377\
\373nn\377\373@@\377\373kk\377\376\375\375\377\375\301\301\377\373@@\377\377\
\377\377\377\377\377\377\377\373@@\377\373@@\377\374\226\226\377\376\363\363\
\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377";
static Fl_RGB_Image image_exit(idata_exit, 48, 16, 4, 0);

Fl_Round_Button *rb28=(Fl_Round_Button *)0;

static void cb_rb28(Fl_Round_Button*, void*) {
  tile=M_TRAMPOLINE1;
}

static unsigned char idata_trampoline[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\n\345\273W$\345\273W=\345\273WU\
\345\273W\206\345\273W\315\0\0\0\0\0\0\0\0\345\273Wp\345\273W\5\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\345\273W\3\345\273W\23\345\273W\17\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\2\345\273W\1\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\346\345\273W\261\345\273WQ\345\273W\24\345\273W\1\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\353\345\273WO\345\273W\2\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\271\345\273W0\345\273W\2\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\317\345\273WR\345\273W\3\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\7\
\345\273W\23\345\273W\2\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\365\345\273W\257\345\273W$\0\0\0\0\0\
\0\0\0\0\0\0\0\345\273W\22\345\273W\206\345\273W\327\345\273W\237\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\233\345\273W*\0\0\0\0\345\273W\255\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377";
static Fl_RGB_Image image_trampoline(idata_trampoline, 64, 16, 4, 0);

Fl_Round_Button *rb29=(Fl_Round_Button *)0;

static void cb_rb29(Fl_Round_Button*, void*) {
  tile=M_BOMB;
}

static unsigned char idata_bomb[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\377\0\0\0\377\0\0\0\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\
\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\
\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_bomb(idata_bomb, 16, 16, 4, 0);

Fl_Round_Button *rb30=(Fl_Round_Button *)0;

static void cb_rb30(Fl_Round_Button*, void*) {
  tile=M_TIMEBONUS;
}

static unsigned char idata_clock[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\
\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\
\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\0\0\0\0\0\0\
\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\377\371\373@\377\
\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\
\377\371\373@\377\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\371\373@\377\371\373@\377\371\373@\377\371\373@\377\371\373@\377\
\371\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0";
static Fl_RGB_Image image_clock(idata_clock, 16, 16, 4, 0);

Fl_Round_Button *rb31=(Fl_Round_Button *)0;

static void cb_rb31(Fl_Round_Button*, void*) {
  tile=M_FULLHEALTH;
}

static unsigned char idata_heart[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\371\373@\22\0\0\0\0\371\373@\
\2\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0";
static Fl_RGB_Image image_heart(idata_heart, 16, 16, 4, 0);

Fl_Round_Button *rb32=(Fl_Round_Button *)0;

static void cb_rb32(Fl_Round_Button*, void*) {
  tile=M_LIFEBONUS;
}

static unsigned char idata_life[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\
\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\
\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\
\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\
\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\
\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\
\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\
\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\
\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\
\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\
\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\373@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_life(idata_life, 16, 16, 4, 0);

Fl_Round_Button *rb33=(Fl_Round_Button *)0;

static void cb_rb33(Fl_Round_Button*, void*) {
  tile=M_MINIHEALTH;
}

static unsigned char idata_minihealth[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\
\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\
\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\
\373@@\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\
\377\373@@\377\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\
\0\0\0\0\373@@\377\373@@\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\373@@\377\
\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\373@@\
\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_minihealth(idata_minihealth, 16, 16, 4, 0);

Fl_Round_Button *rb34=(Fl_Round_Button *)0;

static void cb_rb34(Fl_Round_Button*, void*) {
  tile=M_SHIELD;
}

static unsigned char idata_shield[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\301\323\
\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\0\0\0\0\0\0\0\0\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\0\0\0\0\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\0\0\0\0\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\301\323\325\377\0\0\0\0\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\0\0\0\0\301\323\
\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\0\0\0\0\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\0\0\0\0\0\0\0\0\301\323\325\377\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\0\0\0\0\0\0\0\0\0\0\0\0\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\
\325\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\301\323\325\377\301\323\325\377\301\
\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\302\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\377\301\323\325\377\301\323\325\377\301\323\325\327\301\323\325<\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\315\301\323\325N\301\323\325\3\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\301\323\325\315\301\323\325\377\301\323\325\377\301\323\325\377\
\301\323\325\377\301\323\325\315\301\323\325M\301\323\325\5\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\301\323\325N\301\323\325\315\
\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325""c\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\301\323\325""c\301\323\325\377\301\323\325\377\301\323\325\377\301\323\325\
\25\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_shield(idata_shield, 16, 16, 4, 0);

Fl_Round_Button *rb35=(Fl_Round_Button *)0;

static void cb_rb35(Fl_Round_Button*, void*) {
  tile=M_YINGYANG;
}

static unsigned char idata_yingyang[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\0\0\
\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\377\0\0\0\377\0\0\
\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\
\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\
\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0";
static Fl_RGB_Image image_yingyang(idata_yingyang, 16, 16, 4, 0);

Fl_Round_Button *rb36=(Fl_Round_Button *)0;

static void cb_rb36(Fl_Round_Button*, void*) {
  tile=M_FRUIT1;
}

static unsigned char idata_fruit[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0@\364\373\377@\364\373\
\377@\364\373\377@\364\373\377@\364\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0@\364\373\377@\364\373\377@\364\
\373\377@\364\373\377@\364\373\377@\364\373\377@\364\373\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0@\364\373\377@\364\
\373\377@\364\373\377@\364\373\377@\364\373\377@\364\373\377@\364\373\377\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0@\364\373\
\377@\364\373\377@\364\373\377@\364\373\377@\364\373\377@\364\373\377@\364\
\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0@\364\373\377@\364\373\377@\364\373\377@\364\373\377@\364\373\377@\364\
\373\377@\364\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0@\364\373\377@\364\373\377@\364\373\377@\364\373\377@\364\373\
\377@\364\373\377@\364\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0@\364\373\377@\364\373\377@\364\373\377@\
\364\373\377@\364\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\
\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\
\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\
\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\
\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\
\373@\377R\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\
\373@\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377R\373@\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_fruit(idata_fruit, 16, 64, 4, 0);

Fl_Round_Button *rb37=(Fl_Round_Button *)0;

static void cb_rb37(Fl_Round_Button*, void*) {
  tile=-1;
}

Fl_Round_Button *rb38=(Fl_Round_Button *)0;

static void cb_rb38(Fl_Round_Button*, void*) {
  tile=M_SLOPELEFT;
}

static unsigned char idata_rampleft[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\212r8\1\212r8(\212r8A\212r8\'\212r8\23\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8(\212r8\306\
\212r8\377\212r8\217\212r8w\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\212r8\1\212r8.\212r8\306\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\1\212r8\7\212r8.\212r8\243\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\23\
\212r8Q\212r8\204\212r8\256\212r8\320\212r8\356\212r8\377\212r8\377\212r8\377\
\212r8\377\213s8\377\220v:\377\222x:\377\222x:\377\220v:\377\213s8\377\212r8\
\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\22\212r8\225\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\213s8\377\
\223y;\377\235\201>\377\241\204@\377\241\204@\377\235\201>\377\223y;\377\213s8\
\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\215t9M\214t8\316\214t8\377\214s8\
\377\213r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\221x:\377\
\235\202>\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\235\202>\
\377\221x:\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\212r8\f\212r8\34\212r8\f\212r8\20\214t8`\222x:\321\225{<\377\
\227|<\377\225{<\377\220w:\377\213r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\225{<\377\241\204@\377\242\206@\377\242\206@\377\242\206@\377\242\206@\
\377\241\204@\377\225{<\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\212r8\3\212r8E\212r8\305\212r8\377\212r8\377\212r8\377\220w:\377\
\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\220w:\377\212r8\377\212r8\
\377\212r8\377\212r8\377\226{<\377\242\205@\377\242\206@\377\242\206@\377\242\
\206@\377\242\206@\377\242\205@\377\226{<\377\212r8\377\212r8\377\0\0\0\0\0\0\
\0\0\0\0\0\0\212r8\b\212r8O\212r8\302\212r8\365\212r8\377\212r8\377\212r8\377\
\212r8\377\225{<\377\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\225{<\
\377\212r8\377\212r8\377\212r8\377\212r8\377\222y;\377\237\203?\377\242\206@\
\377\242\206@\377\242\206@\377\242\206@\377\237\203?\377\222y;\377\212r8\377\
\212r8\377\0\0\0\0\0\0\0\0\212r8}\212r8\353\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\227|<\377\227|<\377\227|<\377\227|<\377\
\227|<\377\227|<\377\227|<\377\212r8\377\212r8\377\212r8\377\212r8\377\215t9\
\377\227|<\377\240\203?\377\242\205@\377\242\205@\377\240\203?\377\227|<\377\
\215t9\377\212r8\377\212r8\377\0\0\0\0\212r8\205\212r8\353\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\223z;\377\
\227|<\377\227|<\377\227|<\377\227|<\377\227|<\377\223z;\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\215t9\377\224z;\377\231~=\377\231~=\377\
\224z;\377\215t9\377\212r8\377\212r8\377\212r8\377\0\0\0\0\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\216u9\377\226{<\377\227|<\377\227|<\377\227|<\377\226{<\377\216u9\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\
\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\216u9\377\222y;\377\225z;\377\222y;\377\
\216u9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\365\212r8\340\212r8\
\321\212r8\321\212r8\340\212r8\365\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377";
static Fl_RGB_Image image_rampleft(idata_rampleft, 32, 16, 4, 0);

Fl_Round_Button *rb39=(Fl_Round_Button *)0;

static void cb_rb39(Fl_Round_Button*, void*) {
  tile=M_SLOPERIGHT;
}

static unsigned char idata_rampright[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\213r8\377\222x:\377\
\233\177=\377\235\202>\377\233\177=\377\222x:\377\213r8\377\212r8\377\212r8\
\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\213r8\377\222x:\377\237\202?\377\
\242\205@\377\242\206@\377\242\205@\377\237\202?\377\222x:\377\213r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\214s8\377\233\200>\377\242\
\205@\377\242\206@\377\242\206@\377\242\206@\377\242\205@\377\233\200>\377\
\214s8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\214t8\
\377\240\204?\377\242\206@\377\242\206@\377\242\206@\377\242\206@\377\242\206@\
\377\240\204?\377\214t8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\214s8\377\236\202>\377\242\205@\377\242\206@\377\242\206@\377\
\242\206@\377\242\205@\377\236\202>\377\214s8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\0\0\0\0\0\0\0\0\0\0\0\0\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\213r8\377\226|<\377\241\
\205@\377\242\206@\377\242\206@\377\242\206@\377\241\205@\377\226|<\377\213r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\0\0\0\0\0\0\0\0\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\215t9\377\227|<\377\237\203?\377\242\205@\377\237\203?\377\227|\
<\377\215t9\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\0\0\0\0";
static Fl_RGB_Image image_rampright(idata_rampright, 32, 16, 4, 0);

Fl_Round_Button *rb40=(Fl_Round_Button *)0;

static void cb_rb40(Fl_Round_Button*, void*) {
  tile=M_SHOOTERRIGHT1;
}

static unsigned char idata_shooter[] =
"\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\
\373\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\
\377M@\373\377M@\373\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0M@\373\377M@\373\377M@\373\377\377\377\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0M@\373R\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377\377\377\377\377\377\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377\377\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\
\373\377M@\373\377M@\373\335M@\373=M@\373\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377\
\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\335M@\373""cM@\373\6\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\346M@\373RM@\373\
\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\302M@\373""1\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\327M@\373""1M@\373\1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M\
@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0M@\373\2M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\
\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0M@\373\377M@\373\377M@\373\377M@\373\377M@\373\377M@\
\373\377M@\373\377\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\212r83\212r8\2\0\0\0\0\212r8\2\
\212r8\n\212r8/\212r8\22\212r8\1\212r8\1\212r8\1\212r8\r\212r8\7\212r8\2\212r8\
\t\212r8\21\212r8\3\212r8\3\212r8\1\212r8\2\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_shooter(idata_shooter, 32, 32, 4, 0);

Fl_Round_Button *rb41=(Fl_Round_Button *)0;

static void cb_rb41(Fl_Round_Button*, void*) {
  tile=M_RING;
}

static unsigned char idata_ring[] =
"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\373@@\274\373@@\340\373@@\366\373@@\376\373@@\366\373@@\340\373@@\
\274\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@$\373@@\
\217\373@@\353\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\353\373@@\217\373@@$\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\373@@\217\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\217\373@@\t\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@L\373@@\337\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\337\373@@L\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@u\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@u\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\204\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\204\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\373@@y\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\310\373@@z\373@@@\373@@\31\373@@\4\373@@\4\373@@\
\31\373@@@\373@@z\373@@\310\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@y\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@V\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\260\373@@=\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@=\373@@\260\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@V\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\33\373@@\355\373@@\377\373@@\377\373@@\377\373@@\377\373@@\366\373@@]\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@]\373@@\366\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\355\373@@\33\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\246\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\331\373@@/\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@/\
\373@@\331\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\246\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@H\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\341\373@@$\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@$\373@@\341\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@H\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@\273\373@@\377\373@@\377\373@@\377\373@@\377\373@@=\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@=\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\273\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\373@@:\373@@\377\373@@\377\373@@\377\373@@\377\373@@x\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\373@@x\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@:\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\227\373@@\377\373@@\377\373@@\
\377\373@@\326\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\326\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\227\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\350\373@@\377\373@@\377\373@@\377\373@@e\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\373@@e\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\350\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\373@@;\373@@\377\373@@\377\373@@\377\373@@\364\373@@\5\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\5\373@@\364\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@;\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@v\373@@\377\373@@\377\373@@\377\373@@\
\244\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\244\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@v\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\247\373@@\377\
\373@@\377\373@@\377\373@@d\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\373@@d\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@\
@\247\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@\315\373@@\377\373@@\377\373@@\377\373@@4\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@4\373@@\377\373@@\377\373@@\377\373@@\377\373@\
@\377\373@@\377\373@@\315\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\373@@\350\373@@\377\373@@\377\373@@\377\373@@\24\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\24\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\350\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\370\373@@\377\373@@\377\
\373@@\377\373@@\4\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@\4\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\370\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@\376\373@@\377\373@@\377\373@@\377\373@@\4\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\4\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\376\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\370\373@@\377\373@@\377\373@@\377\373@@\24\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\24\373@@\377\373@\
@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\370\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\350\373@@\377\373@@\
\377\373@@\377\373@@4\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@4\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\350\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
\315\373@@\377\373@@\377\373@@\377\373@@d\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\373@@d\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\315\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\373@@\247\373@@\377\373@@\377\373@@\377\373@@\244\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\244\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\247\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@v\373@@\377\373@@\377\373@\
@\377\373@@\364\373@@\5\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\5\373@@\
\364\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@v\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@;\373@\
@\377\373@@\377\373@@\377\373@@\377\373@@e\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\373@@e\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@\
@\377\373@@;\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\373@@\350\373@@\377\373@@\377\373@@\377\373@@\326\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\326\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\350\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\227\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@x\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@x\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\227\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\
:\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@=\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@=\373@\
@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@:\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\273\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\341\373@@$\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\373@@$\373@@\341\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\273\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@H\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\331\373@@/\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@/\373@@\331\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@H\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\373@@\246\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\366\373@@]\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@]\373@@\366\373@\
@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\246\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\33\373@@\355\373@\
@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\260\373@@=\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@=\373@@\260\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\355\373@@\33\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\373@@V\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\310\373@@z\373@@@\373@@\31\373@@\4\
\373@@\4\373@@\31\373@@@\373@@z\373@@\310\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@V\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\373@@y\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@y\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\204\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\204\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@u\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@u\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@L\373@@\337\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\337\373@@L\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@\377\373@@\377\373@@\377\373@@\377\373@@\
\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\217\373@@\t\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\373@@\217\373@@\353\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\
\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\377\373@@\353\373@@\
\217\373@@$\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\373@@I\373@@\212\373@@\
\274\373@@\340\373@@\366\373@@\376\373@@\366\373@@\340\373@@\274\373@@\212\
\373@@I\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0";
static Fl_RGB_Image image_ring(idata_ring, 48, 48, 4, 0);

Fl_Round_Button *rb42=(Fl_Round_Button *)0;

static void cb_rb42(Fl_Round_Button*, void*) {
  tile=0;
}

Fl_Round_Button *rb43=(Fl_Round_Button *)0;

static void cb_rb43(Fl_Round_Button*, void*) {
  tile=M_45SLOPELEFT;
}

static unsigned char idata_45left[] =
"\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?~\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?~\215\306?\377\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?~\215\306?\377\215\306?\377\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?~\215\306?\377\
\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?~\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?~\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?~\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?~\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?~\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?~\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?~\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?~\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?~\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\0\215\306?~\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?~\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?~\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377";
static Fl_RGB_Image image_45left(idata_45left, 16, 16, 4, 0);

Fl_Round_Button *rb44=(Fl_Round_Button *)0;

static void cb_rb44(Fl_Round_Button*, void*) {
  tile=M_45SLOPERIGHT;
}

static unsigned char idata_45right[] =
"\215\306?~\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\377\215\306?~\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?~\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\377\215\306?\377\215\306?\377\215\306?~\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?~\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?~\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?~\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?~\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?~\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?~\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
~\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?~\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?~\215\306?\0\215\306?\0\215\306?\0\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?~\215\306?\0\215\306?\0\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?~\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
~";
static Fl_RGB_Image image_45right(idata_45right, 16, 16, 4, 0);

Fl_Round_Button *rb45=(Fl_Round_Button *)0;

static void cb_rb45(Fl_Round_Button*, void*) {
  tile=M_STEEPSLOPELEFT;
}

static unsigned char idata_steepleft[] =
"\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\?\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\275\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\?\215\306?\377\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\275\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\?\215\306?\377\215\306?\377\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\275\215\306?\377\215\
\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\?\
\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\275\215\306?\377\215\306?\377\215\306?\377\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\?\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\275\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\?\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\275\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\?\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\275\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\?\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\275\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\?\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\275\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\?\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\275\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\?\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\275\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\?\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\275\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\
\215\306?\0\215\306?\?\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\275\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\0\215\306?\?\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\
\0\215\306?\275\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\0\215\306?\?\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\275\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\?\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\275\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377";
static Fl_RGB_Image image_steepleft(idata_steepleft, 16, 32, 4, 0);

Fl_Round_Button *rb46=(Fl_Round_Button *)0;

static void cb_rb46(Fl_Round_Button*, void*) {
  tile=M_STEEPSLOPERIGHT;
}

static unsigned char idata_steepright[] =
"\215\306?\?\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\?\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\377\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?B\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\
\377\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?B\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\
\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?B\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?B\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?B\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?B\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?B\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\275\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?B\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\275\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?B\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?B\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\275\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?B\215\306?\0\215\306?\0\215\306?\0\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\275\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
B\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\275\215\306?\0\215\306?\
\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?B\215\306?\0\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\275\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
B\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\275";
static Fl_RGB_Image image_steepright(idata_steepright, 16, 32, 4, 0);

Fl_Round_Button *rb47=(Fl_Round_Button *)0;

static void cb_rb47(Fl_Round_Button*, void*) {
  tile=M_GENTLESLOPELEFT;
}

static unsigned char idata_gentleleft[] =
"\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\306?\325\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\'\215\306?~\215\306?\325\215\306?\377\215\306?\377\215\306?\377\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\306?\325\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\'\215\306?~\215\306?\325\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\
\306?~\215\306?\325\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\
\306?\325\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\306?\
\325\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\306?\325\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\306?\
\325\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\
\306?\325\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\'\215\306?~\215\306?\325\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\'\215\306?~\215\306?\325\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\306?\325\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\'\215\306?~\215\306?\325\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\0\215\306?\0\215\306?\0\215\306?\'\215\306?~\215\306?\325\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\'\215\306?~\215\306?\325\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377";
static Fl_RGB_Image image_gentleleft(idata_gentleleft, 48, 16, 4, 0);

Fl_Round_Button *rb48=(Fl_Round_Button *)0;

static void cb_rb48(Fl_Round_Button*, void*) {
  tile=M_GENTLESLOPERIGHT;
}

static unsigned char idata_gentleright[] =
"\215\306?\325\215\306?~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\377\215\306?\377\215\306?\377\215\306?\325\215\306?~\215\306?\'\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\325\215\306?~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\325\215\306?~\215\306?\'\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\325\215\306?~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\325\215\306?~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\325\215\306?\
~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\325\215\306?~\215\306?\'\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\325\215\306?~\215\306?\'\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\325\215\306?~\215\306?\'\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\325\215\306?\
~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\325\215\306?~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\
\0\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\325\215\306?~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\
\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\325\215\306?~\215\306?\'\215\306?\0\
\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\325\215\306?\
~\215\306?\'\215\306?\0\215\306?\0\215\306?\0\215\306?\377\215\306?\377\215\
\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\
\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\377\215\306?\
\377\215\306?\377\215\306?\325\215\306?~\215\306?\'";
static Fl_RGB_Image image_gentleright(idata_gentleright, 48, 16, 4, 0);

Fl_Round_Button *rb49=(Fl_Round_Button *)0;

static void cb_rb49(Fl_Round_Button*, void*) {
  tile=M_POUNDPLATFORM;
}

static unsigned char idata_poundplatform[] =
"\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\345\273W\377\345\273W\377\345\273W\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\273W\377\
\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\
\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\345\273W\377";
static Fl_RGB_Image image_poundplatform(idata_poundplatform, 16, 16, 4, 0);

Fl_Round_Button *rb50=(Fl_Round_Button *)0;

static void cb_rb50(Fl_Round_Button*, void*) {
  tile=M_ROCKETPLATFORM;
}

static unsigned char idata_rocketthrough[] =
"\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\345\273W\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\212r8\
\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r8\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\
\377\212r8\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\377\212r\
8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\212r8\377\345\273W\377\345\
\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\212r8\377\212r8\377\212r8\
\377\212r8\377\212r8\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\
\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\
\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377\345\273W\377";
static Fl_RGB_Image image_rocketthrough(idata_rocketthrough, 16, 16, 4, 0);

Fl_Round_Button *rb51=(Fl_Round_Button *)0;

static void cb_rb51(Fl_Round_Button*, void*) {
  tile=M_EXPLODINGGROUND;
}

static unsigned char idata_exploding[] =
"\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\371\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\363\252\252\252\333\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\325\252\252\252\223\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\220\252\252\252-\252\252\252\374\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\374\252\252\252-\252\252\252\0\252\252\252\223\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\
\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\
\377\252\252\252\377\252\252\252\220\252\252\252\0\252\252\252\0\252\252\252\
\6\252\252\252\267\252\252\252\377\252\252\252\377\252\252\252\377\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\377\252\252\252\267\252\252\252\6\252\252\252\0\252\
\252\252\0\252\252\252\0\252\252\252\0\252\252\252r\252\252\252\366\252\252\
\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\252\252\377\252\
\252\252\377\252\252\252\366\252\252\252r\252\252\252\0\252\252\252\0\252\252\
\252\0\252\252\252\0\252\252\252\0\252\252\252\0\252\252\252\0\252\252\252\'\
\252\252\252\215\252\252\252\317\252\252\252\377\252\252\252\377\252\252\252\
\317\252\252\252\215\252\252\252\'\252\252\252\0\252\252\252\0\252\252\252\0\
\252\252\252\0";
static Fl_RGB_Image image_exploding(idata_exploding, 16, 16, 4, 0);

Fl_Round_Button *rb52=(Fl_Round_Button *)0;

static void cb_rb52(Fl_Round_Button*, void*) {
  tile=M_BOMBABLEWALL;
}

Fl_Round_Button *rb53=(Fl_Round_Button *)0;

static void cb_rb53(Fl_Round_Button*, void*) {
  tile=M_INVISIBLEPLATFORM;
}

Fl_Round_Button *rb54=(Fl_Round_Button *)0;

static void cb_rb54(Fl_Round_Button*, void*) {
  tile=M_EVILDUCKLEFT1;
}

static unsigned char idata_evilduck[] =
"\377\0\0\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\226\247\224\0\16""C\7\0\fA\5\0\fA\5\36\fA\5""3\fA\5""3\fA\
\5\0\fA\5\0\fA\5\0XyT\0\321\322\321\0\326\326\326\0\326\326\326\0\326\326\326\
\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\377\0\0\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\242\257\240\0\21""E\n\0\fA\5\0\fA\5\223\fA\5\377\fA\5\377\fA\5\377\
\fA\5\360\fA\5\226\fA\5\f\fA\5\0>f9\0\310\313\307\0\326\326\326\0\326\326\326\
\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\377\0\0\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\253\
\266\252\0\23""F\f\0\fA\5\0\fA\5x\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\
\377\fA\5\377\fA\5\311\fA\5\6\fA\5\0)V#\0\271\301\270\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\377\0\
\0\0\326\326\326\0\326\326\326\0\326\326\326\0\275\300\236\0""cx\32\0\22""D\6\
\0\fA\5""0\fA\5\374\21(\16\377\16""8\b\377\fA\5\377\fA\5\377\fA\5\377\fA\5\
\377\fA\5\377\fA\5i\fA\5\0\fA\5\0\32L\24\0\303\310\302\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\377\0\0\0\326\
\326\326\0\343\326\241\0\364\322>\0\377\325(\0\377\325(\0\225\225\31\0\fA\5\
\303\fA\5\377\16""9\b\377\f?\6\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\
\377\fA\5\272\fA\5\0\fA\5\0\30J\21\0\324\324\324\0\326\326\326\0\326\326\326\
\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\377\0\0\0\362\325]\0\377\
\325(\0\377\325(\0\377\325(\0\377\325(\0\364\316&{\32J\7\377\fA\5\377\fA\5\
\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\344\fA\5\0\fA\
\5\0GmB\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\
\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\377\0\0\0\377\325(\0\377\325(\0\377\325(\0\377\325(\
\36\377\325(\245\377\325(\377y\203\25\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\
\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\t\fA\5\0~\225{\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\377\0\0\0\377\325(\0\377\325(\'\377\325(\237\377\325(\374\377\325(\
\377\377\325(\377\356\313&\377#O\b\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\
\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\30\fA\5\0\262\274\261\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\377\0\0\0\377\325(\237\377\325(\377\377\325(\377\377\325(\377\377\325(\
\377\377\325(\377\377\325(\377\324\273\"\377.V\n\377\fA\5\360\fA\5\377\fA\5\
\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5\'\37O\31\0\326\326\326\0\326\
\326\326\0\277\277\277\0\250\250\250\0\265\265\265\0\300\300\300\0\312\312\
\312\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\377\0\0\0\377\325(\377\377\325(\377\377\325(\377\377\325(\317\
\377\325(\256\377\325(\215\377\325(`\377\325(3\342\304$\0#O\b\0\fA\5\215\fA\5\
\377\fA\5\377\fA\5\377\fA\5\377\fA\5\377\fA\5?SvO\0\326\326\326\0\256\256\256\
\0\212\212\212\0\212\212\212\0\212\212\212\0\212\212\212\0\212\212\212\0\212\
\212\212\0\230\230\230\0\243\243\243\0\256\256\256\0\270\270\270\0\307\307\
\307\0\322\322\322\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\377\0\0\0\377\325(\6\377\325(\'\377\325(\0\377\325(\0\377\325(\0\377\
\325(\0\353\311%\0\225\225\31\0\32J\7\0\fA\5\0\fA\5\22\fA\5\363\fA\5\377\fA\5\
\377\fA\5\377/\\)\377\233\256\230\204\312\320\311\0\263\263\263\0\212\212\212\
\0\212\212\212\0\212\212\212\25\212\212\212""3\212\212\212H\212\212\212""f\
\212\212\212<\212\212\212*\212\212\212\0\212\212\212\0\212\212\212\0\212\212\
\212\0\212\212\212\0\220\220\220\0\233\233\233\0\250\250\250\0\265\265\265\0\
\300\300\300\0\312\312\312\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\377\0\0\0\377\325(\0\377\325(\0\377\325(\0\374\324,\0\315\272=\0k~\'\0\
\17""C\5\0\fA\5\0\fA\5\0\fA\5\0\fA\5\0\fA\5\275\"R\33\377W{S\377\271\305\267\
\377\346\347\345\377\266\260\243\366\314\313\311~\214\214\214""f\212\212\212\
\220\212\212\212\330\212\212\212\377\212\212\212\377\212\212\212\377\212\212\
\212\377\212\212\212\377\212\212\212\377\212\212\212\366\212\212\212\261\212\
\212\212`\212\212\212\25\212\212\212\0\212\212\212\0\212\212\212\0\212\212\
\212\0\212\212\212\0\212\212\212\0\212\212\212\0\212\212\212\0\230\230\230\0\
\246\246\246\0\322\322\322\0\326\326\326\0\312\310\307\0\264\260\253\0\324\
\324\323\0\326\326\326\0\377\0\0\0\373\325:\0\357\325n\0\342\326\243\0\327\
\326\320\0\326\326\326\0\326\326\326\0\301\306\300\0\210\234\205\0""Ei>\0\26H\
\17\0@g:\0\327\334\325\264\333\336\331\377\277\300\264\377\204w\\\377""E0\6\
\377\254\247\232\377\325\325\325\377\225\225\225\377\212\212\212\377\212\212\
\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\
\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\
\212\212\212\377\212\212\212\325\212\212\212\231\212\212\212Z\212\212\212!\
\212\212\212\0\212\212\212\0\212\212\212\0\212\212\212\0\214\214\214\0\277\
\277\277\0\310\306\304\0yl`\0""6\37\13\36.\26\1""3.\26\1""9H3\"\30\377\0\0\0~q\
W\0~qW\0iY:\0`P-\0`P-\0L8\17\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0K7\16\0S@\31\
\311""C.\3\377""C.\3\377""C.\3\377TB\34\377\326\326\326\377\326\326\326\377\
\322\322\322\377\261\261\261\377\217\217\217\377\212\212\212\377\212\212\212\
\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\
\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\
\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\355\
\212\212\212\314\213\213\213\314\274\274\274\314\233\222\213\330""6\37\13\377.\
\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\352\377\0\0\0""C.\3\0""C.\3\0""C\
.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\
\352""C.\3\377""C.\3\377""C.\3\377ykP\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\323\323\323\377\270\270\270\377\237\237\237\377\
\213\213\213\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\
\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\
\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\215\
\215\215\377\271\270\270\377qcV\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\
\26\1\377.\26\1\377.\26\1\317\377\0\0\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\
\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\33""C.\3\377""C.\3\377""C.\3\
\377""C.\3\377\221\207s\377\326\326\326\377\326\326\326\377\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\322\322\322\
\377\273\273\273\377\243\243\243\377\222\222\222\377\212\212\212\377\212\212\
\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\212\212\377\212\
\212\212\377\212\212\212\377\212\212\212\377\224\224\224\377\263\261\256\377N:\
)\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\352""2\
\33\6$\377\0\0\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\
\3\0""C.\3\0""C.\3\0""C.\3KC.\3\377""C.\3\377""C.\3\377""C.\3\377\237\227\207\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\
\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\315\315\315\377\273\273\273\377\252\252\252\377\
\235\235\235\377\231\231\231\377\212\212\212\377\212\212\212\377\232\232\232\
\377\272\272\272\377\267\263\257\377>(\25\377.\26\1\377.\26\1\377.\26\1\377.\
\26\1\377.\26\1\377.\26\1\377.\26\1\344""4\35\t-\245\236\227\0\377\0\0\0""C.\
\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""\
C.\3uC.\3\377""C.\3\377""C.\3\377""C.\3\377\246\237\220\377\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\
\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\262\255\251\377:$\
\20\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\322""\
8!\16\36\256\251\244\0\326\326\326\0\377\0\0\0""C.\3\0""C.\3\0""C.\3\0""C.\3\
\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\215""C.\3\377""C.\3\
\377""C.\3\377""C.\3\377\253\245\230\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\
\326\377\326\326\326\377\254\247\241\377""6\37\13\377.\26\1\377.\26\1\377.\26\
\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\300>(\25\22\266\262\256\0\326\326\
\326\0\326\326\326\0\377\0\0\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\
\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\215""C.\3\377""C.\3\377""C.\3\377""C.\
\3\377\247\241\223\377\326\326\326\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\274\271\
\265\377""8!\16\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\
\377.\26\1\237""B-\32\6\276\273\270\0\326\326\326\0\326\326\326\0\326\326\326\
\0\377\0\0\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""\
C.\3\0""C.\3\0""C.\3""fC.\3\377""C.\3\377""C.\3\377""C.\3\377\242\233\214\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\
\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\326\326\326\377TA1\377.\26\1\377.\26\1\377.\26\1\
\377.\26\1\377.\26\1\377.\26\1\374.\26\1lJ6$\0\304\302\277\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\377\0\0\0""C.\3\0""C.\3\0""C.\3\0""\
C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\22""C.\3\355""C.\
\3\377""C.\3\377""C.\3\377\226\215z\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\
\326\377""8!\16\377.\26\1\377.\26\1\377.\26\1\377.\26\1\377.\26\1\355.\26\1""E\
R?.\0\312\310\307\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\377\0\0\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\
\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3""EC.\3\366""C.\3\377""C.\3\377\212\
\177i\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377_N@\377.\26\1\377.\26\1\
\377.\26\1\377.\26\1\330.\26\1$YH8\0\316\315\314\0\326\326\326\0\326\326\326\
\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\377\0\0\0\240\231\
\211\0XF!\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C\
.\3\0""C.\3\0""C.\3\36""C.\3\245""C.\3\377ykP\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\
\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\
\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\
\326\326\326\377\243\233\225\377.\26\1\377.\26\1\377.\26\1\267.\26\1\fcSE\0\
\322\321\321\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\377\0\0\0\326\326\326\0\323\322\321\0\
\231\221\177\0Q>\27\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""\
C.\3\0""C.\3\0""C.\3\0""C.\3""6dT2\201\326\326\326\275\326\326\326\374\326\
\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\
\326\377\326\326\326\377N:)\371.\26\1~.\26\1\3oaT\0\324\324\323\0\326\326\326\
\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\377\0\0\0\326\326\326\0\326\326\326\0\326\326\326\0\
\317\316\314\0\223\211u\0O<\24\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\
\3\0""C.\3\0""C.\3\0""C.\3\0M:\22\0\326\326\326\0\326\326\326\6\326\326\326""B\
\326\326\326i\337\326\261\302\326\326\324\274\326\326\326\330\326\326\326\377\
\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\
\377\326\326\326\377\326\326\326\377\326\326\326\377\326\326\326\333\326\326\
\326\212\260\253\246-0\30\4\0yl`\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\377\0\0\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\321\320\317\0\231\221\177\0VD\36\0""C.\3\0""C.\3\
\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0\314\312\307\0\326\326\326\
\0\326\326\326\0\377\325(i\377\325({\326\326\326\0\326\326\326\0\326\326\326\
\0\326\326\326\0\326\326\326\25\326\326\326""3\343\326\236K\363\325\\\253\326\
\326\326""3\326\326\326\t\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\256\251\244\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\377\0\0\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\324\324\324\0\242\
\233\214\0]L(\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0""C.\3\0\263\256\244\0\
\326\326\326\0\377\325(N\377\325(\314\377\325(\6\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\377\
\325(\215\377\325(\36\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\377\0\0\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\254\247\232\0""fV5\0""C.\3\0""C.\3\0""C.\3\
\0""C.\3\0\226\215z\0\377\325(-\377\325(\363\377\325(0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\377\325(\36\377\325(\223\326\326\326\0\326\326\326\0\326\326\
\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\
\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\326\
\326\326\0\326\326\326\0\326\326\326\0\326\326\326\0\377\0\0\0\377\0\0\0\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\325(\0\377\325(\0\377\325(\
\17\377\325(f\377\325(f\377\325(Q\377\325(3\377\325(\25\377\325(\0\377\325(\0\
\377\325(\33\377\325(\344\377\325(\204\377\325(\0\377\325(\0\377\325(\0\377\
\325(\0\377\325(\0\377\325(\0\377\325(\0\377\325(\0\377\325(\0\377\325(\0\377\
\325(\237\377\325(\17\377\325(\0\377\325(\0\377\0\0\0\377\0\0\0\377\0\0\0\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\
\0\0\377\0\0\0\377\0\0\0\377\325(\0\377\325(\0\377\325(\250\377\325(\377\377\
\325(\377\377\325(\377\377\325(\377\377\325(\377\377\325(\377\377\325(\330\
\377\325(\355\377\325(\330\377\325(\6\377\325(\0\377\325(\0\377\325(*\377\325(\
\245\377\325(\245\377\325(\231\377\325(f\377\325(Z\377\325(3\377\325(\33\377\
\325({\377\325(i\377\325(\0\377\325(\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\
\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0\377\325(\0\377\325(\0\377\325(\30\377\325(3\377\325(3\
\377\325(3\377\325(3\377\325(-\377\325(\0\377\325(\0\377\325(\0\377\325(\0\
\377\325(\0\377\325(\0\377\325(\0\377\325(\226\377\325(\377\377\325(\377\377\
\325(\377\377\325(\352\377\325(\314\377\325(\314\377\325(\314\377\325(\314\
\377\325(~\377\325(\0\377\325(\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\
\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\377\0\0\0\
\377\0\0\0\377\0\0\0";
static Fl_RGB_Image image_evilduck(idata_evilduck, 48, 32, 4, 0);

Fl_Round_Button *rb55=(Fl_Round_Button *)0;

static void cb_rb55(Fl_Round_Button*, void*) {
  tile=M_SLIPPERY45LEFT;
}

Fl_Round_Button *rb56=(Fl_Round_Button *)0;

static void cb_rb56(Fl_Round_Button*, void*) {
  tile=M_SLIPPERY45RIGHT;
}

Fl_Round_Button *rb57=(Fl_Round_Button *)0;

static void cb_rb57(Fl_Round_Button*, void*) {
  tile=M_YELLOWTELEPORTER;
}

Fl_Round_Button *rb58=(Fl_Round_Button *)0;

static void cb_rb58(Fl_Round_Button*, void*) {
  tile=M_BLUETELEPORTER;
}

Fl_Round_Button *rb59=(Fl_Round_Button *)0;

static void cb_rb59(Fl_Round_Button*, void*) {
  tile=M_GREENTELEPORTER;
}

Fl_Round_Button *rb60=(Fl_Round_Button *)0;

static void cb_rb60(Fl_Round_Button*, void*) {
  tile=M_REDTELEPORTER;
}

Fl_Round_Button *rb61=(Fl_Round_Button *)0;

static void cb_rb61(Fl_Round_Button*, void*) {
  tile=M_YELLOWKEY;
}

Fl_Round_Button *rb62=(Fl_Round_Button *)0;

static void cb_rb62(Fl_Round_Button*, void*) {
  tile=M_BLUEKEY;
}

Fl_Round_Button *rb63=(Fl_Round_Button *)0;

static void cb_rb63(Fl_Round_Button*, void*) {
  tile=M_GREENKEY;
}

Fl_Round_Button *rb64=(Fl_Round_Button *)0;

static void cb_rb64(Fl_Round_Button*, void*) {
  tile=M_REDKEY;
}

Fl_Round_Button *rb65=(Fl_Round_Button *)0;

static void cb_rb65(Fl_Round_Button*, void*) {
  tile=M_YELLOWDOOR1;
}

Fl_Round_Button *rb66=(Fl_Round_Button *)0;

static void cb_rb66(Fl_Round_Button*, void*) {
  tile=M_BLUEDOOR1;
}

Fl_Round_Button *rb67=(Fl_Round_Button *)0;

static void cb_rb67(Fl_Round_Button*, void*) {
  tile=M_GREENDOOR1;
}

Fl_Round_Button *rb68=(Fl_Round_Button *)0;

static void cb_rb68(Fl_Round_Button*, void*) {
  tile=M_REDDOOR1;
}

static void cb_New(Fl_Menu_*, void*) {
  new_level();
}

static void cb_Open(Fl_Menu_*, void*) {
  open_level();
}

static void cb_Save(Fl_Menu_*, void*) {
  save_level();
}

static void cb_Save1(Fl_Menu_*, void*) {
  saveas_level();
}

static void cb_Quit(Fl_Menu_*, void*) {
  quit_editor();
}

static void cb_Undo(Fl_Menu_*, void*) {
  undo();
}

static void cb_Redo(Fl_Menu_*, void*) {
  redo();
}

static void cb_Quick(Fl_Menu_*, void*) {
  make_quickstart()->show();
}

static void cb_About(Fl_Menu_*, void*) {
  make_about()->show();
}

Fl_Menu_Item menu_[] = {
 {"&File", 0,  0, 0, 64, 0, 0, 14, 56},
 {"&New", 0x4006e,  (Fl_Callback*)cb_New, 0, 0, 0, 0, 14, 56},
 {"&Open...", 0x4006f,  (Fl_Callback*)cb_Open, 0, 128, 0, 0, 14, 56},
 {"&Save", 0x40073,  (Fl_Callback*)cb_Save, 0, 0, 0, 0, 14, 56},
 {"Save &As...", 0x40061,  (Fl_Callback*)cb_Save1, 0, 128, 0, 0, 14, 56},
 {"Quit", 0x40071,  (Fl_Callback*)cb_Quit, 0, 0, 0, 0, 14, 56},
 {0},
 {"&Edit", 0,  0, 0, 64, 0, 0, 14, 56},
 {"Undo", 0x4007a,  (Fl_Callback*)cb_Undo, 0, 0, 0, 0, 14, 56},
 {"Redo", 0x40079,  (Fl_Callback*)cb_Redo, 0, 0, 0, 0, 14, 56},
 {0},
 {"&Help", 0,  0, 0, 64, 0, 0, 14, 56},
 {"&Quick Start", 0xffbe,  (Fl_Callback*)cb_Quick, 0, 0, 0, 0, 14, 56},
 {"&About", 0xffc9,  (Fl_Callback*)cb_About, 0, 0, 0, 0, 14, 56},
 {0},
 {0}
};

Fl_Counter *counterWidth=(Fl_Counter *)0;

Fl_Counter *counterHeight=(Fl_Counter *)0;

Fl_Scrollbar *verticalScroll=(Fl_Scrollbar *)0;

static void cb_verticalScroll(Fl_Scrollbar*, void*) {
  game.t=TILEHEIGHT*(int)verticalScroll->value();
editorMap->redraw();
}

Fl_Scrollbar *horizontalScroll=(Fl_Scrollbar *)0;

static void cb_horizontalScroll(Fl_Scrollbar*, void*) {
  game.l=TILEWIDTH*(int)horizontalScroll->value();
editorMap->redraw();
}

Fl_Editor_Map *editorMap=(Fl_Editor_Map *)0;

Fl_Button *comments=(Fl_Button *)0;

static void cb_comments(Fl_Button*, void*) {
  const char *s=fl_input("Comments for thie level",levelComments);
if(s) strcpy(levelComments,s);
}

Fl_Preview_Map *previewMap=(Fl_Preview_Map *)0;

int main(int argc, char **argv) {
  Fl_Double_Window* w;
  new_game();
if(!mapImage) mapImage=new Fl_PNG_Image("gfx.png");
  { Fl_Double_Window* o = mainWindow = new Fl_Double_Window(720, 553, "Jump Gunnar Jump Level Editor by HardHat");
    w = o;
    o->deactivate();
    { Fl_Group* o = new Fl_Group(10, 40, 710, 185, "Tile Selection");
      o->box(FL_ROUNDED_BOX);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      { Fl_Round_Button* o = rb01 = new Fl_Round_Button(25, 55, 50, 50);
        o->tooltip("Solid Ground");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_solidground);
        o->callback((Fl_Callback*)cb_rb01);
        update_button(rb01,M_SOLIDGROUND);
      }
      { Fl_Round_Button* o = rb02 = new Fl_Round_Button(75, 55, 50, 50);
        o->tooltip("Secret Area");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_secretarea);
        o->callback((Fl_Callback*)cb_rb02);
        update_button(rb02,M_SECRETAREA);
      }
      { Fl_Round_Button* o = rb03 = new Fl_Round_Button(130, 55, 50, 50);
        o->tooltip("Fancy Solid Ground");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_fancysolidground);
        o->callback((Fl_Callback*)cb_rb03);
        update_button(rb03,M_FANCYSOLIDGROUND);
      }
      { Fl_Round_Button* o = rb04 = new Fl_Round_Button(180, 55, 50, 50);
        o->tooltip("Tree");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_tree);
        o->callback((Fl_Callback*)cb_rb04);
        update_button(rb04,M_TREE);
      }
      { Fl_Round_Button* o = rb05 = new Fl_Round_Button(235, 55, 50, 50);
        o->tooltip("Fence");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_fence);
        o->callback((Fl_Callback*)cb_rb05);
        update_button(rb05,M_FENCE);
      }
      { Fl_Round_Button* o = rb06 = new Fl_Round_Button(290, 45, 35, 25);
        o->tooltip("top left platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb06);
        update_button(rb06,M_PLATFORMTL);
      }
      { Fl_Round_Button* o = rb07 = new Fl_Round_Button(410, 45, 65, 55);
        o->tooltip("Decoration 1");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_deco1);
        o->callback((Fl_Callback*)cb_rb07);
        update_button(rb07,M_DECORATION1);
      }
      { Fl_Round_Button* o = rb08 = new Fl_Round_Button(475, 45, 60, 55);
        o->tooltip("Decoration 2");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_deco2);
        o->callback((Fl_Callback*)cb_rb08);
        update_button(rb08,M_DECORATION2);
      }
      { Fl_Round_Button* o = rb09 = new Fl_Round_Button(535, 45, 40, 20);
        o->tooltip("Slippery left");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_slipL);
        o->callback((Fl_Callback*)cb_rb09);
        update_button(rb09,M_SLIPPERYL);
      }
      { Fl_Round_Button* o = rb10 = new Fl_Round_Button(325, 45, 40, 25);
        o->tooltip("top platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb10);
        update_button(rb10,M_PLATFORMTL+1);
      }
      { Fl_Round_Button* o = rb11 = new Fl_Round_Button(290, 65, 35, 25);
        o->tooltip("left platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb11);
        update_button(rb11,M_PLATFORMTL+16);
      }
      { Fl_Round_Button* o = rb12 = new Fl_Round_Button(325, 65, 40, 25);
        o->tooltip("center platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb12);
        update_button(rb12,M_PLATFORMTL+17);
      }
      { Fl_Round_Button* o = rb13 = new Fl_Round_Button(290, 85, 35, 25);
        o->tooltip("bottom left platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb13);
        update_button(rb13,M_PLATFORMTL+32);
      }
      { Fl_Round_Button* o = rb14 = new Fl_Round_Button(325, 85, 40, 25);
        o->tooltip("bottom centre platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb14);
        update_button(rb14,M_PLATFORMTL+33);
      }
      { Fl_Round_Button* o = rb15 = new Fl_Round_Button(365, 45, 35, 25);
        o->tooltip("top right platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb15);
        update_button(rb15,M_PLATFORMTL+2);
      }
      { Fl_Round_Button* o = rb16 = new Fl_Round_Button(365, 65, 40, 25);
        o->tooltip("right platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb16);
        update_button(rb16,M_PLATFORMTL+18);
      }
      { Fl_Round_Button* o = rb17 = new Fl_Round_Button(365, 85, 35, 25);
        o->tooltip("bottom right platform");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_TL);
        o->callback((Fl_Callback*)cb_rb17);
        update_button(rb17,M_PLATFORMTL+34);
      }
      { Fl_Round_Button* o = rb18 = new Fl_Round_Button(535, 65, 40, 20);
        o->tooltip("Slippery right");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_slipR);
        o->callback((Fl_Callback*)cb_rb18);
        update_button(rb18,M_SLIPPERYR);
      }
      { Fl_Round_Button* o = rb19 = new Fl_Round_Button(535, 85, 40, 20);
        o->tooltip("Slippery ground");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_slipT);
        o->callback((Fl_Callback*)cb_rb19);
        update_button(rb19,M_SLIPPERYT);
      }
      { Fl_Round_Button* o = rb20 = new Fl_Round_Button(25, 120, 35, 25);
        o->tooltip("Bird");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_bird);
        o->callback((Fl_Callback*)cb_rb20);
        update_button(rb20,M_BIRDRIGHT1);
      }
      { Fl_Round_Button* o = rb21 = new Fl_Round_Button(65, 120, 35, 25);
        o->tooltip("Chick");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_chick);
        o->callback((Fl_Callback*)cb_rb21);
        update_button(rb21,M_CHICKRIGHT1);
      }
      { Fl_Round_Button* o = rb22 = new Fl_Round_Button(105, 115, 55, 35);
        o->tooltip("Chest");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_chest);
        o->callback((Fl_Callback*)cb_rb22);
        update_button(rb22,M_CHEST1);
      }
      { Fl_Round_Button* o = rb23 = new Fl_Round_Button(165, 110, 40, 45);
        o->tooltip("Checkpoint");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_checkpoint);
        o->callback((Fl_Callback*)cb_rb23);
        update_button(rb23,M_CHECKPOINT);
      }
      { Fl_Round_Button* o = rb24 = new Fl_Round_Button(205, 120, 35, 25);
        o->tooltip("Climber Left");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_crawlerleft);
        o->callback((Fl_Callback*)cb_rb24);
        update_button(rb24,M_WALLCLIMBERLEFT);
      }
      { Fl_Round_Button* o = rb25 = new Fl_Round_Button(240, 120, 35, 25);
        o->tooltip("Climber Right");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_crawlerright);
        o->callback((Fl_Callback*)cb_rb25);
        update_button(rb25,M_WALLCLIMBERRIGHT);
      }
      { Fl_Round_Button* o = rb26 = new Fl_Round_Button(280, 110, 55, 45);
        o->tooltip("Clouds");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_cloud);
        o->callback((Fl_Callback*)cb_rb26);
        update_button(rb26,M_FANCYSKY);
      }
      { Fl_Round_Button* o = rb27 = new Fl_Round_Button(335, 105, 65, 25);
        o->tooltip("Exit");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_exit);
        o->callback((Fl_Callback*)cb_rb27);
        update_button(rb27,M_EXIT);
      }
      { Fl_Round_Button* o = rb28 = new Fl_Round_Button(25, 155, 80, 20);
        o->tooltip("Trampoline");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_trampoline);
        o->callback((Fl_Callback*)cb_rb28);
        update_button(rb28,M_TRAMPOLINE1);
      }
      { Fl_Round_Button* o = rb29 = new Fl_Round_Button(110, 155, 35, 25);
        o->tooltip("Bomb");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_bomb);
        o->callback((Fl_Callback*)cb_rb29);
        update_button(rb29,M_BOMB);
      }
      { Fl_Round_Button* o = rb30 = new Fl_Round_Button(150, 155, 35, 25);
        o->tooltip("Bonus time");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_clock);
        o->callback((Fl_Callback*)cb_rb30);
        update_button(rb30,M_TIMEBONUS);
      }
      { Fl_Round_Button* o = rb31 = new Fl_Round_Button(190, 155, 35, 25);
        o->tooltip("Full health");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_heart);
        o->callback((Fl_Callback*)cb_rb31);
        update_button(rb31,M_FULLHEALTH);
      }
      { Fl_Round_Button* o = rb32 = new Fl_Round_Button(225, 155, 35, 25);
        o->tooltip("Free Life");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_life);
        o->callback((Fl_Callback*)cb_rb32);
        update_button(rb32,M_LIFEBONUS);
      }
      { Fl_Round_Button* o = rb33 = new Fl_Round_Button(260, 155, 35, 25);
        o->tooltip("Mini Health");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_minihealth);
        o->callback((Fl_Callback*)cb_rb33);
        update_button(rb33,M_MINIHEALTH);
      }
      { Fl_Round_Button* o = rb34 = new Fl_Round_Button(295, 155, 35, 25);
        o->tooltip("Shield (immunity to damage)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_shield);
        o->callback((Fl_Callback*)cb_rb34);
        update_button(rb34,M_SHIELD);
      }
      { Fl_Round_Button* o = rb35 = new Fl_Round_Button(330, 155, 35, 25);
        o->tooltip("Doppleganger (Ying yang)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_yingyang);
        o->callback((Fl_Callback*)cb_rb35);
        update_button(rb35,M_YINGYANG);
      }
      { Fl_Round_Button* o = rb36 = new Fl_Round_Button(370, 130, 40, 55);
        o->tooltip("Fruit");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_fruit);
        o->callback((Fl_Callback*)cb_rb36);
        update_button(rb36,M_FRUIT1);
      }
      { Fl_Round_Button* o = rb37 = new Fl_Round_Button(190, 200, 50, 20, "Sky");
        o->tooltip("Sky");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)cb_rb37);
      }
      { Fl_Round_Button* o = rb38 = new Fl_Round_Button(410, 100, 50, 25);
        o->tooltip("Ramp left");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_rampleft);
        o->callback((Fl_Callback*)cb_rb38);
        update_button(rb38,M_SLOPELEFT);
      }
      { Fl_Round_Button* o = rb39 = new Fl_Round_Button(470, 100, 50, 25);
        o->tooltip("Ramp right");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_rampright);
        o->callback((Fl_Callback*)cb_rb39);
        update_button(rb39,M_SLOPERIGHT);
      }
      { Fl_Round_Button* o = rb40 = new Fl_Round_Button(365, 190, 45, 30);
        o->tooltip("Shooter");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_shooter);
        o->callback((Fl_Callback*)cb_rb40);
        update_button(rb40,M_SHOOTERRIGHT1);
      }
      { Fl_Round_Button* o = rb41 = new Fl_Round_Button(265, 180, 60, 45);
        o->tooltip("Ring (3 per level)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_ring);
        o->callback((Fl_Callback*)cb_rb41);
        update_button(rb41,M_RING);
      }
      { Fl_Round_Button* o = rb42 = new Fl_Round_Button(190, 180, 55, 20, "Start");
        o->tooltip("Start point for hero");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)cb_rb42);
      }
      { Fl_Round_Button* o = rb43 = new Fl_Round_Button(575, 45, 35, 20);
        o->tooltip("left 45 degree");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_45left);
        o->callback((Fl_Callback*)cb_rb43);
        update_button(rb43,M_45SLOPELEFT);
      }
      { Fl_Round_Button* o = rb44 = new Fl_Round_Button(615, 45, 40, 20);
        o->tooltip("right 45 degree");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_45right);
        o->callback((Fl_Callback*)cb_rb44);
        update_button(rb44,M_45SLOPERIGHT);
      }
      { Fl_Round_Button* o = rb45 = new Fl_Round_Button(575, 70, 40, 35);
        o->tooltip("left steep");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_steepleft);
        o->callback((Fl_Callback*)cb_rb45);
        update_button(rb45,M_STEEPSLOPELEFT);
      }
      { Fl_Round_Button* o = rb46 = new Fl_Round_Button(615, 70, 40, 35);
        o->tooltip("right steep");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_steepright);
        o->callback((Fl_Callback*)cb_rb46);
        update_button(rb46,M_STEEPSLOPERIGHT);
      }
      { Fl_Round_Button* o = rb47 = new Fl_Round_Button(575, 105, 70, 25);
        o->tooltip("gentle left slope");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_gentleleft);
        o->callback((Fl_Callback*)cb_rb47);
        update_button(rb47,M_GENTLESLOPELEFT);
      }
      { Fl_Round_Button* o = rb48 = new Fl_Round_Button(645, 105, 70, 25);
        o->tooltip("gentle right slope");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_gentleright);
        o->callback((Fl_Callback*)cb_rb48);
        update_button(rb48,M_GENTLESLOPERIGHT);
      }
      { Fl_Round_Button* o = rb49 = new Fl_Round_Button(660, 45, 35, 20);
        o->tooltip("Pound through ground");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb49);
        update_button(rb49,M_POUNDPLATFORM);
      }
      { Fl_Round_Button* o = rb50 = new Fl_Round_Button(660, 75, 40, 20);
        o->tooltip("Rocket through ground");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_rocketthrough);
        o->callback((Fl_Callback*)cb_rb50);
        update_button(rb50,M_ROCKETPLATFORM);
      }
      { Fl_Round_Button* o = rb51 = new Fl_Round_Button(335, 130, 35, 20);
        o->tooltip("Exploding ground");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_exploding);
        o->callback((Fl_Callback*)cb_rb51);
        update_button(rb51,M_EXPLODINGGROUND);
      }
      { Fl_Round_Button* o = rb52 = new Fl_Round_Button(25, 180, 35, 20);
        o->tooltip("Bombable wall");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb52);
        update_button(rb52,M_BOMBABLEWALL);
      }
      { Fl_Round_Button* o = rb53 = new Fl_Round_Button(65, 180, 35, 20);
        o->tooltip("Invisible ground");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb53);
        update_button(rb53,M_INVISIBLEPLATFORM);
      }
      { Fl_Round_Button* o = rb54 = new Fl_Round_Button(110, 180, 70, 40);
        o->tooltip("Anders the Evil Duck");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_evilduck);
        o->callback((Fl_Callback*)cb_rb54);
        update_button(rb54,M_EVILDUCKLEFT1);
      }
      { Fl_Round_Button* o = rb55 = new Fl_Round_Button(25, 200, 35, 20);
        o->tooltip("Slippery Slope Left");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb55);
        update_button(rb55,M_SLIPPERY45LEFT);
      }
      { Fl_Round_Button* o = rb56 = new Fl_Round_Button(65, 200, 35, 20);
        o->tooltip("Slippery slope right");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb56);
        update_button(rb56,M_SLIPPERY45RIGHT);
      }
      { Fl_Round_Button* o = rb57 = new Fl_Round_Button(420, 175, 60, 45);
        o->tooltip("Yellow teleporter (2 per level)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_ring);
        o->callback((Fl_Callback*)cb_rb57);
        update_button(rb57,M_YELLOWTELEPORTER);
      }
      { Fl_Round_Button* o = rb58 = new Fl_Round_Button(485, 175, 60, 45);
        o->tooltip("Blue teleporter (2 per level)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_ring);
        o->callback((Fl_Callback*)cb_rb58);
        update_button(rb58,M_BLUETELEPORTER);
      }
      { Fl_Round_Button* o = rb59 = new Fl_Round_Button(550, 175, 60, 45);
        o->tooltip("Green teleporter (2 per level)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_ring);
        o->callback((Fl_Callback*)cb_rb59);
        update_button(rb59,M_GREENTELEPORTER);
      }
      { Fl_Round_Button* o = rb60 = new Fl_Round_Button(615, 175, 60, 45);
        o->tooltip("Red teleporter (2 per level)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_ring);
        o->callback((Fl_Callback*)cb_rb60);
        update_button(rb60,M_REDTELEPORTER);
      }
      { Fl_Round_Button* o = rb61 = new Fl_Round_Button(685, 130, 35, 20);
        o->tooltip("Yellow Key (opens yellow doors)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb61);
        update_button(rb61,M_YELLOWKEY);
      }
      { Fl_Round_Button* o = rb62 = new Fl_Round_Button(685, 150, 35, 20);
        o->tooltip("Blue key (opens blue door)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb62);
        update_button(rb62,M_BLUEKEY);
      }
      { Fl_Round_Button* o = rb63 = new Fl_Round_Button(685, 170, 35, 20);
        o->tooltip("Green key (opens green doors)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb63);
        update_button(rb63,M_GREENKEY);
      }
      { Fl_Round_Button* o = rb64 = new Fl_Round_Button(685, 190, 35, 20);
        o->tooltip("Red key (opens red doors)");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_poundplatform);
        o->callback((Fl_Callback*)cb_rb64);
        update_button(rb64,M_REDKEY);
      }
      { Fl_Round_Button* o = rb65 = new Fl_Round_Button(410, 125, 50, 50);
        o->tooltip("Yellow door");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_solidground);
        o->callback((Fl_Callback*)cb_rb65);
        update_button(rb65,M_YELLOWDOOR1);
      }
      { Fl_Round_Button* o = rb66 = new Fl_Round_Button(460, 125, 50, 50);
        o->tooltip("Blue door");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_secretarea);
        o->callback((Fl_Callback*)cb_rb66);
        update_button(rb66,M_BLUEDOOR1);
      }
      { Fl_Round_Button* o = rb67 = new Fl_Round_Button(515, 125, 50, 50);
        o->tooltip("Green door");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_fancysolidground);
        o->callback((Fl_Callback*)cb_rb67);
        update_button(rb67,M_GREENDOOR1);
      }
      { Fl_Round_Button* o = rb68 = new Fl_Round_Button(565, 125, 50, 50);
        o->tooltip("Red door");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->image(image_tree);
        o->callback((Fl_Callback*)cb_rb68);
        update_button(rb68,M_REDDOOR1);
      }
      o->end();
    }
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(0, 0, 720, 25);
      o->menu(menu_);
    }
    { Fl_Counter* o = counterWidth = new Fl_Counter(15, 235, 70, 25, "Width");
      o->type(1);
      o->minimum(16);
      o->maximum(1024);
      o->step(16);
      o->value(32);
    }
    { Fl_Counter* o = counterHeight = new Fl_Counter(95, 235, 70, 25, "Height");
      o->type(1);
      o->minimum(16);
      o->maximum(1024);
      o->step(16);
      o->value(16);
    }
    { Fl_Scrollbar* o = verticalScroll = new Fl_Scrollbar(690, 235, 25, 285);
      o->maximum(16);
      o->callback((Fl_Callback*)cb_verticalScroll);
      o->linesize(8);
    }
    { Fl_Scrollbar* o = horizontalScroll = new Fl_Scrollbar(195, 525, 490, 25);
      o->type(1);
      o->callback((Fl_Callback*)cb_horizontalScroll);
    }
    { Fl_Box* o = new Fl_Box(195, 235, 490, 285);
      o->box(FL_DOWN_BOX);
    }
    { Fl_Editor_Map* o = editorMap = new Fl_Editor_Map(200, 243, 480, 272);
      o->box(FL_NO_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_BLACK);
      o->align(FL_ALIGN_CENTER);
      o->when(FL_WHEN_RELEASE);
    }
    { Fl_Button* o = comments = new Fl_Button(45, 285, 95, 30, "Comments...");
      o->callback((Fl_Callback*)cb_comments);
    }
    { Fl_Preview_Map* o = previewMap = new Fl_Preview_Map(5, 330, 180, 190, "overall map");
      o->tooltip("Preview of the overall map");
      o->box(FL_ENGRAVED_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_BLACK);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    o->end();
  }
  w->show(argc, argv);
  return Fl::run();
}

Fl_Double_Window *aboutBox=(Fl_Double_Window *)0;

static void cb_OK(Fl_Return_Button*, void*) {
  aboutBox->hide();
delete aboutBox;
aboutBox=0;
}

Fl_Double_Window* make_about() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = aboutBox = new Fl_Double_Window(267, 100, "About Jump Gunnar Jump Level Editor");
    w = o;
    { Fl_Return_Button* o = new Fl_Return_Button(155, 60, 90, 25, "OK");
      o->callback((Fl_Callback*)cb_OK);
    }
    { Fl_Output* o = new Fl_Output(25, 25, 230, 25, "Jump Gunnar Jump Level Editor by HardHat");
      o->box(FL_THIN_UP_BOX);
      o->align(FL_ALIGN_TOP_LEFT);
      o->value("Version 1.2, 2006-06-28");
    }
    o->end();
  }
  return w;
}

Fl_Double_Window *quickstartWindow=(Fl_Double_Window *)0;

Fl_Double_Window* make_quickstart() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = quickstartWindow = new Fl_Double_Window(428, 309, "Quick Start for UM Ed");
    w = o;
    { Fl_Output* o = new Fl_Output(0, 5, 425, 300);
      o->type(12);
      o->value("Select new or load an existing level to start.\nThen,\nSelect a radio button up top for which sprite to draw on the map.\nUse left mouse button to draw (some sprites you need to click for each one), or use right mouse button for sky, or middle button for solid ground.\nUse undo and redo to if you are indecisive.\nEmail: hardhat@mail.ru\nhttp://www.adamcon.org/~dmwick/psp/");
    }
    o->end();
  }
  return w;
}
#include<stack>
static std::stack<Undo> undoList,redoList;

void new_level() {
  int w,h;
if(dirty) {
	if(fl_ask("Changes have been made.  Save first?")) {
		save_level();
	}
}
const char *s=fl_input("What width of map?","128");
w=128;
if(!s) return;
sscanf(s,"%d",&w);
if(w<0) w=32;
s=fl_input("What height of map?","128");
h=128;
if(!s) return;
sscanf(s,"%d",&h);
if(h<0) h=32;
construct_level(w,h);
resized_map();
dirty=0;
while(!undoList.empty()) undoList.pop();
while(!redoList.empty()) redoList.pop();
}

void save_level() {
  if(strlen(currentlevel)>4) {
	save_level(currentlevel);
	dirty=0;
} else {
	saveas_level();
}
}

void saveas_level() {
  char *fname=fl_file_chooser("Save As Level","*.txt",0);
if(fname) {
	strcpy(currentlevel,fname);
	save_level(fname);
}
}

void open_level() {
  char *fname=fl_file_chooser("Open Level File","*.txt",0);
if(fname) {
   editMode=1;
   load_level(fname);
   strcpy(currentlevel,fname);
}
resized_map();
dirty=0;
while(!undoList.empty()) undoList.pop();
while(!redoList.empty()) redoList.pop();
}

void quit_editor() {
  exit(1);
}

void draw_tile(int id,int x,int y) {
  //if(x+TILEWIDTH+editorMap->x()<0) return;
//if(y+TILEHEIGHT+editorMap->y()<0) return;
if(x>=TILEWIDTH*SCREENWIDTH) return;
if(y>=TILEHEIGHT*SCREENHEIGHT) return;

//if(id>=0) printf("Drawing tile %d at %d,%d +(%d,%d)\n",id,x,y,editorMap->x(),editorMap->y());
y+=editorMap->y();
x+=editorMap->x();
if(!mapImage) mapImage=new Fl_PNG_Image("gfx.png");
if(mapImage) {
	fl_color(proposed?0x80:0,proposed?0xff:0xc0,proposed?0x80:0xc0);
	fl_rectf(x,y,TILEWIDTH,TILEHEIGHT);
	if(id>0) mapImage->draw(x,y,TILEWIDTH,TILEHEIGHT,(id%TILESACROSS)*TILEWIDTH,(id/TILESACROSS)*TILEHEIGHT);
} else {
	fl_color((uchar)(id&1?0xff:0),(uchar)(id&2?0xff:0),(uchar)(id&4?0xff:0));
	fl_rectf(x,y,TILEWIDTH,TILEHEIGHT);
}
}

void draw_tile_rect(int id,int x,int y,int w,int h) {
}

void play_sound(int id) {
}

void resized_map() {
  counterWidth->value(game.w);
counterHeight->value(game.h);
horizontalScroll->value(game.l/TILEWIDTH,SCREENWIDTH,0,game.w);
verticalScroll->value(game.t/TILEHEIGHT,SCREENHEIGHT,0,game.h);
//editorMap->size(game.w*TILEWIDTH,game.h*TILEHEIGHT);
editorMap->damage(FL_DAMAGE_ALL);
previewMap->damage(FL_DAMAGE_ALL);
}

void update_button(Fl_Round_Button *button,int tile) {
  Fl_Image *img;
struct TileProp *tileProp=tile_to_prop(tile);
int w=1,h=1;
if(tileProp) {
	w=tileProp->gfxw;
	h=tileProp->gfxh;
}
if(mapImage && img) {
	unsigned char *buf=new unsigned char[w*TILEWIDTH*h*TILEHEIGHT*3];
	int x,y;
	int ox,oy;
	int i;
	int depth=mapImage->d();

	const char *rawGfx=mapImage->data()[0];
	for(i=0;i<w*TILEWIDTH*h*TILEHEIGHT*3;i++) {
		switch(i%3) {
		case 0: buf[i]=0x88; break;
		case 1: buf[i]=0xcc; break;
		case 2: buf[i]=0xff; break;
		case 3: buf[i]=0xff; break;
		}
	}
	i=0;
	ox=(tile%TILESACROSS)*TILEWIDTH;
	oy=(tile/TILESACROSS)*TILEHEIGHT;
	for(y=0;y<TILEHEIGHT*h;y++) {
		for(x=0;x<TILEWIDTH*w;x++) {
			buf[i++]=rawGfx[((oy+y)*TILESACROSS*TILEWIDTH+(ox+x))*depth];
			buf[i++]=rawGfx[((oy+y)*TILESACROSS*TILEWIDTH+(ox+x))*depth+1];
			buf[i++]=rawGfx[((oy+y)*TILESACROSS*TILEWIDTH+(ox+x))*depth+2];
			if(depth>3) {
				if(rawGfx[((oy+y)*TILESACROSS*TILEWIDTH+(ox+x))*depth+3]==0) {
					buf[i-3]=0x88;
					buf[i-2]=0xcc;
					buf[i-1]=0xff;
				}
			}
		}
	}
	img=new Fl_RGB_Image(buf,w*TILEWIDTH,h*TILEHEIGHT,3);
	button->image(img);
}
}

void undo() {
  if(!undoList.empty()) {
	int i,j;
	int tileLink=undoList.top().tile;
	dirty--;

	while(undoList.size()>0 && undoList.top().tile==tileLink) {
		// We have something.
		Undo undoItem=undoList.top();
		undoList.pop();
		Undo redoItem;
		redoItem.x=undoItem.x;
		redoItem.y=undoItem.y;
		int x=redoItem.x;
		int y=redoItem.y;
		redoItem.w=undoItem.w;
		redoItem.h=undoItem.h;
		redoItem.tile=undoItem.tile;
		for(j=0;j<undoItem.h;j++) {
			for(i=0;i<undoItem.w;i++) {
				if(x+i>game.w || y+j>game.h) continue;
				redoItem.cells[j][i]=game.map[(x+i)+game.w*(y+j)];
				game.map[(x+i)+game.w*(y+j)]=undoItem.cells[j][i];
			}
		}
	
		redoList.push(redoItem);
		editorMap->damage(FL_DAMAGE_ALL,x*TILEWIDTH,y*TILEHEIGHT,undoItem.w*TILEWIDTH,undoItem.h*TILEHEIGHT);
	}
	editorMap->redraw();
	previewMap->redraw();
}
}

void redo() {
  if(!redoList.empty()) {
	int i,j;
	int tileLink=redoList.top().tile;
	dirty++;

	while(redoList.size()>0 && redoList.top().tile==tileLink) {
		// We have something.
		Undo undoItem=redoList.top();
		redoList.pop();
		Undo redoItem;
		redoItem.x=undoItem.x;
		redoItem.y=undoItem.y;
		int x=redoItem.x;
		int y=redoItem.y;
		redoItem.w=undoItem.w;
		redoItem.h=undoItem.h;
		redoItem.tile=undoItem.tile;
		for(j=0;j<undoItem.h;j++) {
			for(i=0;i<undoItem.w;i++) {
				if(x+i>game.w || y+j>game.h) continue;
				redoItem.cells[j][i]=game.map[(x+i)+game.w*(y+j)];
				game.map[(x+i)+game.w*(y+j)]=undoItem.cells[j][i];
			}
		}
	
		undoList.push(redoItem);
		editorMap->damage(FL_DAMAGE_ALL,x*TILEWIDTH,y*TILEHEIGHT,undoItem.w*TILEWIDTH,undoItem.h*TILEHEIGHT);
	}
	editorMap->redraw();
	previewMap->redraw();
}
}

void save_undo(int x,int y, int w, int h, int tile) {
  while(!redoList.empty()) redoList.pop();
dirty++;
int i,j;

Undo undoItem;
undoItem.x=x;
undoItem.y=y;
undoItem.w=w;
undoItem.h=h;
undoItem.tile=tile;
for(j=0;j<undoItem.h;j++) {
	for(i=0;i<undoItem.w;i++) {
		if(x+i>game.w || y+j>game.h) continue;
		undoItem.cells[j][i]=game.map[(x+i)+game.w*(y+j)];
	}
}
	
undoList.push(undoItem);
}
